install.packages("margrittr")
install.packages("tydr")
install.packages("tidyverse")

library(magrittr)
library(tidyverse)
library(readxl)
library(dplyr)

x <- FAOSTAT_data_9_28_2020_Yields <- read_excel("C:/Users/molch/OneDrive - Wageningen University & Research/PhD_WJS/Academic/RQ1/Data_analysis/Raw_dat/FAOCrops/FAOSTAT_data_9-28-2020_Yields.xlsx", 
                                            sheet = "FAOSTAT_data_9-28-2020_Yields")
                                      
# View(FAOSTAT_data_9_28_2020_Yields)
# head(x)
# head(z)

z <- left_join(x,z, by='FAO_code')

t <- z %>% 
  select(Area, FAO_code, Year, Unit, Value, FAO_name, Cat) %>%
  filter(Year == 2010)
  
z <- na.omit(t)  

# Data

Yld_dat <- z %>% filter(Unit == "hg/ha") 
Yld_dat <- as_tibble(Yld_dat)
Yld_dat %>% spread(Cat, Value)
prop <- Yld_dat %>% group_by(Area, Cat)%>%
  spread(Cat, Value)%>%
  mutate(prop = (sum(treenut) / sum(treenut, other)))
# 

# mutate(sepal_by_petal_l = Sepal.Length/Petal.Length)


Area_dat <- z %>% filter(Unit == "ha")

# Check that
Yld_dat %>% 
  group_by(Area & Cat) %>%
  mutate(prop = (price / sum(price) * 100) %>% 
           round(digits = 0)) %>%
  select(-duration) 


# New approach  -----------------------------------------------------------
# Idea: 
# 1. Load all the harvested area and yields (GeoTIFF) 
# 2. Extract to point of the Spam cells
# 3.       
# 4. Then look at the proportion between Treenuts and the rest of spam crop others for each pixel

# Zonal statistics  -------------------------------------------------------
library(sf)
library(raster)
library(sp) 
library(dplyr)
library(spatialEco)
library(exactextractr)
library(sp)

wd=setwd("C:/Users/molch/OneDrive - Wageningen University & Research/PhD_WJS/Academic/RQ1/Data_analysis/Raw_dat/Zonation/GADM/gadm36_shp")

# Load and check shapefile 
shape=read_sf(dsn = wd, layer = "gadm36") # multipolygons containing all admin levels globally
shape=dplyr::select(shape, 'UID', 'geometry', 'GID_0', 'GID_1')
# shape_fil=filter(shape, GID_0 == 'FIN')
# class(shape)
# Load raster 
# ylds - Nuts
rast_walnut_yld = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/walnut_YieldPerHectare.tif")
# class(rast_walnut_yld)

# rast_walnut_withoutNA = rast_walnut_yld
# # 
# mean(rast_walnut_yld$walnut_YieldPerHectare)
# mean(rast_walnut_withoutNA$walnut_YieldPerHectare)
# rast_walnut_withoutNA[rast_walnut_withoutNA$walnut_YieldPerHectare == 0] <- NA
# check=as.raster(rast_walnut_withoutNA)
# 
# cellStats(rast_walnut_withoutNA$walnut_YieldPerHectare, mean)
# 
# cellStats(rast_walnut_withoutNA, mean)
# cellStats(rast_walnut_yld, mean)
# rast_walnut_withoutNA$walnut_YieldPerHectare

rast_almond_yld = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/almond_YieldPerHectare.tif")
# rast_almond_yld[rast_almond_yld$almond_YieldPerHectare == 0] <- NA
rast_chestnut_yld = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/chestnut_YieldPerHectare.tif")
rast_cashew_yld = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/cashew_YieldPerHectare.tif")
rast_pistachio_yld = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/pistachio_YieldPerHectare.tif")
rast_kolanut_yld = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/kolanut_YieldPerHectare.tif")
rast_hazelnut_yld = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/hazelnut_YieldPerHectare.tif")
rast_brazil_yld = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/brazil_YieldPerHectare.tif")
rast_areca_yld = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/areca_YieldPerHectare.tif")
rast_nutnes_yld  = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/nutnes_YieldPerHectare.tif")

# 0's to Na's
# rast_almond_yldNA=rast_almond_yld[rast_almond_yld$almond_YieldPerHectare == 0] <- NA
# 
rast_almond_yld[rast_almond_yld$almond_YieldPerHectare == 0] <- NA
# # 
# cellStats(rast_walnut_withoutNA$walnut_YieldPerHectare, min)
# cellStats(rast_walnut_yld$walnut_YieldPerHectare, min)

# rast_almond_yld

# yld - Rest
rast_anise_yld = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/Rest/aniseetc_YieldPerHectare.tif')
rast_chili_yld = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/Rest/chilleetc_YieldPerHectare.tif')
rast_cinnamon_yld = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/Rest/cinnamon_YieldPerHectare.tif')
rast_ginger_yld = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/Rest/ginger_YieldPerHectare.tif')
rast_hop_yld = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/Rest/hop_YieldPerHectare.tif')
rast_mate_yld = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/Rest/mate_YieldPerHectare.tif')
rast_nutmeg_yld = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/Rest/nutmeg_YieldPerHectare.tif')
rast_pepper_yld = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/Rest/pepper_YieldPerHectare.tif')
rast_peppermint_yld = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/Rest/peppermint_YieldPerHectare.tif')
rast_pyreth_yld = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/Rest/pyrethrum_YieldPerHectare.tif')
rast_ramie_yld = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/Rest/ramie_YieldPerHectare.tif')
rast_ruber_yld = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/Rest/rubber_YieldPerHectare.tif')
rast_spices_yld = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/Rest/spicenes_YieldPerHectare.tif')
rast_sugarnes_yld = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/Rest/sugarnes_YieldPerHectare.tif')
rast_vanilla_yld = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_yld_Treenuts/Rest/vanilla_YieldPerHectare.tif')

# Production - treenuts
rast_walnut_pd = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/walnut_Production.tif")
rast_almond_pd = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/almond_Production.tif")
rast_chestnut_pd = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/chestnut_Production.tif")
rast_cashew_pd = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/cashew_Production.tif")
rast_pistachio_pd = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/pistachio_Production.tif")
rast_kolanut_pd = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/kolanut_Production.tif")
rast_pdzelnut_pd = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/hazelnut_Production.tif")
rast_brazil_pd = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/brazil_Production.tif")
rast_areca_pd = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/areca_Production.tif")
rast_nutnes_pd  = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/nutnes_Production.tif")

# Production  -rest
rast_anise_pd = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/Rest/aniseetc_Production.tif')
rast_chili_pd = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/Rest/chilleetc_Production.tif')
rast_cinnamon_pd = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/Rest/cinnamon_Production.tif')
rast_ginger_pd = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/Rest/ginger_Production.tif')
rast_hop_pd = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/Rest/hop_Production.tif')
rast_mate_pd = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/Rest/mate_Production.tif')
rast_nutmeg_pd = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/Rest/nutmeg_Production.tif')
rast_pepper_pd = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/Rest/pepper_Production.tif')
rast_peppermint_pd = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/Rest/peppermint_Production.tif')
rast_pyreth_pd = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/Rest/pyrethrum_Production.tif')
rast_ramie_pd = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/Rest/ramie_Production.tif')
rast_ruber_pd = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/Rest/rubber_Production.tif')
rast_spices_pd = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/Rest/spicenes_Production.tif')
rast_sugarnes_pd = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/Rest/sugarnes_Production.tif')
rast_vanilla_pd = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_pd_Treenuts/Rest/vanilla_Production.tif')

# Production - rest





# harv - treentus 
rast_walnut_ha = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/walnut_HarvestedAreaHectares.tif")
rast_almond_ha = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/almond_HarvestedAreaHectares.tif")
rast_chestnut_ha = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/chestnut_HarvestedAreaHectares.tif")
rast_cashew_ha = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/cashew_HarvestedAreaHectares.tif")
rast_pistachio_ha = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/pistachio_HarvestedAreaHectares.tif")
rast_kolanut_ha = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/kolanut_HarvestedAreaHectares.tif")
rast_hazelnut_ha = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/hazelnut_HarvestedAreaHectares.tif")
rast_brazil_ha = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/brazil_HarvestedAreaHectares.tif")
rast_areca_ha = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/areca_HarvestedAreaHectares.tif")
rast_nutnes_ha  = raster("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/nutnes_HarvestedAreaHectares.tif")

# ha_area -rest
rast_anise_ha = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/Rest/aniseetc_HarvestedAreaHectares.tif')
rast_chili_ha = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/Rest/chilleetc_HarvestedAreaHectares.tif')
rast_cinnamon_ha = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/Rest/cinnamon_HarvestedAreaHectares.tif')
rast_ginger_ha = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/Rest/ginger_HarvestedAreaHectares.tif')
rast_hop_ha = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/Rest/hop_HarvestedAreaHectares.tif')
rast_mate_ha = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/Rest/mate_HarvestedAreaHectares.tif')
rast_nutmeg_ha = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/Rest/nutmeg_HarvestedAreaHectares.tif')
rast_pepper_ha = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/Rest/pepper_HarvestedAreaHectares.tif')
rast_peppermint_ha = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/Rest/peppermint_HarvestedAreaHectares.tif')
rast_pyreth_ha = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/Rest/pyrethrum_HarvestedAreaHectares.tif')
rast_ramie_ha = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/Rest/ramie_HarvestedAreaHectares.tif')
rast_ruber_ha = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/Rest/rubber_HarvestedAreaHectares.tif')
rast_spices_ha = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/Rest/spicenes_HarvestedAreaHectares.tif')
rast_sugarnes_ha = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/Rest/sugarnes_HarvestedAreaHectares.tif')
rast_vanilla_ha = raster('D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/1_ha_Treenuts/Rest/vanilla_HarvestedAreaHectares.tif')



# yld_list=list(rast_almond_yld, rast_cashew_yld, rast_chestnut_yld, rast_hazelnut_yld, rast_kolanut_yld, rast_pistachio_yld, rast_walnut_yld)
# stack_yld=stack(rast_almond_yld, rast_cashew_yld, rast_chestnut_yld, rast_hazelnut_yld, rast_kolanut_yld, rast_pistachio_yld, rast_walnut_yld)
# stack_ha=stack(rast_almond_ha, rast_cashew_ha, rast_chestnut_ha, rast_hazelnut_ha, rast_kolanut_ha, rast_pistachio_ha, rast_walnut_ha)
# 
# dat$mean.nfertilizer_global
# summary(dat$mean.nfertilizer_global)
# 

# Perform zonal statistics ------------------------------------------------
# FunZone_yld=function(rast,shape, na.rm=T){ # raster and vector
#   c=zonal.stats(shape, rast, stats = c("Fun_nzmean")) 
#   c$UID <- shape$UID  # assigning the identifier of the original df to the extracted df
#   merge(shape, c, by.x = 'UID', by.y = 'UID') # merge the two files together
# }

FunZone_sum=function(rast){ # raster and vector
  c=zonal.stats(shape, rast, stats = c("sum")) 
  c$UID <- shape$UID  # assigning the identifier of the original df to the extracted df
  dat <- merge(shape, c, by.x = 'UID', by.y = 'UID') # merge the two files together
}

# 
# original ----------------------------------------------------------------
FunZone=function(rast, shape, na.rm=T){ # raster and vector
  c=zonal.stats(shape, rast, stats = c("mean"))
  c$UID <- shape$UID  # assigning the identifier of the original df to the extracted df
  dat <- merge(shape, c, by.x = 'UID', by.y = 'UID') # merge the two files togethere
}

# # test ignoring 0s --------------------------------------------------------
# nzmean <- function(x) {
#   zvals <- x==0
#   if (all(zvals)) 0 else mean(x[!zvals])
# }
# 
# Fun_nzmean=function(r, na.rm=F){
#   mean(r[r!=0])
#   }
# 
# FunZone_yld_0=function(rast,shape){ # raster and vector
#   c=zonal.stats(shape, rast, stats = c("nzmean")) 
#   c$UID <- shape$UID  # assigning the identifier of the original df to the extracted df
#   merge(shape, c, by.x = 'UID', by.y = 'UID') # merge the two files together
# }
# 
# # Test raster 
# v2=raster::extract(rast_walnut_yld,shape_fil,fun='Fun_nzmean')


# Yields ------------------------------------------------------------------
# Apply zonal stats to treenuts 
ex_walnut_yld = FunZone_yld(rast_walnut_yld,shape_fil)
ex_walnut_yld_0 = FunZone_yld(rast_walnut_yld,shape_fil)

mean(ex_walnut_yld$mean.walnut_YieldPerHectare)
mean(ex_walnut_yld_0$mean.walnut_YieldPerHectare)
mean(ex_walnut_withNA_FIn$mean.walnut_YieldPerHectare)

ex_walnut_withNA_FIn = FunZone_yld(rast_walnut_withoutNA,shape_fil)
ex_walnut_yld$nzmean.walnut_YieldPerHectare
max(ex_walnut_withNA_FIn$mean.walnut_YieldPerHectare)


ex_almond_yld = FunZone_yld(rast_almond_yld)
ex_chestnut_yld = FunZone_yld(rast_chestnut_yld)
ex_cashew_yld = FunZone_yld(rast_cashew_yld)
ex_pistachio_yld = FunZone_yld(rast_pistachio_yld)
ex_kolanut_yld = FunZone_yld(rast_kolanut_yld)
ex_hazelnut_yld = FunZone_yld(rast_hazelnut_yld)
ex_brazil_yld = FunZone_yld(rast_brazil_yld)
ex_areca_yld = FunZone_yld(rast_areca_yld)
ex_nutnes_yld = FunZone_yld(rast_nutnes_yld)

# Apply zonal stats to rest 
ex_anise_yld = FunZone_yld(rast_anise_yld)
ex_chili_yld = FunZone_yld(rast_chili_yld)
ex_cinnamon_yld =FunZone_yld(rast_cinnamon_yld) 
ex_ginger_yld = FunZone_yld(rast_ginger_yld)
ex_hop_yld = FunZone_yld(rast_hop_yld)
ex_mate_yld = FunZone_yld(rast_mate_yld)
ex_nutmeg_yld = FunZone_yld(rast_nutmeg_yld)
ex_pepper_yld = FunZone_yld(rast_pepper_yld)
ex_peppermint_yld = FunZone_yld(rast_peppermint_yld)
ex_pyreth_yld = FunZone_yld(rast_pyreth_yld)
ex_ramie_yld = FunZone_yld(rast_ramie_yld)
ex_ruber_yld = FunZone_yld(rast_ruber_yld)
ex_spices_yld = FunZone_yld(rast_spices_yld)
ex_sugarnes_yld = FunZone_yld(rast_sugarnes_yld)
ex_vanilla_yld = FunZone_yld(rast_vanilla_yld)

# Join  columns (cbind)
lst.ex.yld = list(ex_walnut_yld,ex_almond_yld,ex_chestnut_yld,ex_cashew_yld,ex_pistachio_yld, ex_kolanut_yld, ex_hazelnut_yld, ex_areca_yld, ex_brazil_yld, ex_nutnes_yld, 
                  ex_anise_yld, ex_chili_yld, ex_cinnamon_yld, ex_ginger_yld, ex_hop_yld, ex_mate_yld, ex_nutmeg_yld, ex_pepper_yld, ex_peppermint_yld, ex_pyreth_yld, ex_ramie_yld, ex_ruber_yld, ex_spices_yld, ex_sugarnes_yld, ex_vanilla_yld)
dat_ex.yld = do.call("cbind", lst.ex.yld) # merging all tech types
# head(dat_ex.yld)

treenut_yld = dat_ex.yld %>% 
  select(UID, GID_0,GID_1,mean.walnut_YieldPerHectare, 
       mean.almond_YieldPerHectare,
       mean.chestnut_YieldPerHectare,
       mean.cashew_YieldPerHectare,
       mean.pistachio_YieldPerHectare,
       mean.kolanut_YieldPerHectare,
       mean.hazelnut_YieldPerHectare, 
       mean.areca_YieldPerHectare, 
       mean.brazil_YieldPerHectare, 
       mean.nutnes_YieldPerHectare, 
       geometry) %>% 
  rowwise()%>%
  mutate(treenut_yld= rowmean(c_across(mean.almond_YieldPerHectare:mean.areca_YieldPerHectare)))%>%
  mutate(treenut_yld= rowmean(c_across(mean.anise_YieldPerHectare:mean.vanilla_YieldPerHectare)))
  
  
# class(treenut_yld)
# write.csv(treenut_yld, 'D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/Treenuts', row.names=T) 
st_write(treenut_yld, "D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/Treenuts/GADM_treenut.shp", driver="ESRI Shapefile")  # create to a shapefile 


# Production  -------------------------------------------------------------

ex_walnut_pd = FunZone_sum(rast_walnut_pd)
ex_almond_pd = FunZone_sum(rast_almond_pd)
ex_chestnut_pd = FunZone_sum(rast_chestnut_pd)
ex_cashew_pd = FunZone_sum(rast_cashew_pd)
ex_pistachio_pd = FunZone_sum(rast_pistachio_pd)
ex_kolanut_pd = FunZone_sum(rast_kolanut_pd)
ex_hazelnut_pd = FunZone_sum(rast_pdzelnut_pd)
ex_brazil_pd = FunZone_sum(rast_brazil_pd)
ex_areca_pd = FunZone_sum(rast_areca_pd)
ex_nutnes_pd = FunZone_sum(rast_nutnes_pd)

# Rest
ex_anise_pd = FunZone_sum(rast_anise_pd)
ex_chili_pd = FunZone_sum(rast_chili_pd)
ex_cinnamon_pd =FunZone_sum(rast_cinnamon_pd) 
ex_ginger_pd = FunZone_sum(rast_ginger_pd)
ex_hop_pd = FunZone_sum(rast_hop_pd)
ex_mate_pd = FunZone_sum(rast_mate_pd)
ex_nutmeg_pd = FunZone_sum(rast_nutmeg_pd)
ex_pepper_pd = FunZone_sum(rast_pepper_pd)
ex_peppermint_pd = FunZone_sum(rast_peppermint_pd)
ex_pyreth_pd = FunZone_sum(rast_pyreth_pd)
ex_ramie_pd = FunZone_sum(rast_ramie_pd)
ex_ruber_pd = FunZone_sum(rast_ruber_pd)
ex_spices_pd = FunZone_sum(rast_spices_pd)
ex_sugarnes_pd = FunZone_sum(rast_sugarnes_pd)
ex_vanilla_pd = FunZone_sum(rast_vanilla_pd)

# list all treenuts
lst.ex.pd = list(ex_walnut_pd,ex_almond_pd,ex_chestnut_pd,ex_cashew_pd,ex_pistachio_pd, ex_kolanut_pd, ex_hazelnut_pd, ex_areca_pd, ex_nut_pd,
                 ex_anise_pd, ex_chili_pd, ex_cinnamon_pd, ex_ginger_pd, ex_hop_pd, ex_mate_pd, ex_nutmeg_pd, ex_pepper_pd, ex_peppermint_pd, ex_pyreth_pd, ex_ramie_pd, ex_ruber_pd, ex_spices_pd, ex_sugarnes_pd, ex_vanilla_pd)
dat_ex.pd = do.call("cbind", lst.ex.pd) # merging all tech types

# list rest

treenut_pd = dat_ex.pd %>% 
  select(UID, GID_0,GID_1,sum.walnut_Production, 
         sum.almond_Production,
         sum.chestnut_Production,
         sum.cashew_Production,
         sum.pistachio_Production,
         sum.kolanut_Production,
         sum.hazelnut_Production, 
         geometry) %>% 
  mutate(treenut_pd= sum(sum.walnut_Production, 
                          sum.almond_Production,
                          sum.chestnut_Production,
                          sum.cashew_Production,
                          sum.pistachio_Production,
                          sum.kolanut_Production,
                          sum.hazelnut_Production))%>%
  mutate(rest_pd = sum(sum.aniseetc_Production,
                       sum.chilleetc_Production,
                       sum.cinnamon_Production,
                       sum.ginger_Production,
                       sum.hop_Production,
                       sum.mate_Production, 
                       sum.nutmeg_Production,
                       sum.pepper_Production,
                       sum.peppermint_Production,
                       sum.pyrethrum_Production,
                       sum.ramie_Production,
                       sum.rubber_Production,
                       sum.spicenes_Production,
                       sum.sugarnes_Production,
                       sum.vanilla_Production))
         
# class(treenut_yld)
# write.csv(treenut_yld, 'D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/Treenuts', row.names=T) 
st_write(treenut_pd, "D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/Treenuts/GADM_treenut_rest_pd.shp", driver="ESRI Shapefile")  # create to a shapefile 


# Harvested area - Treenuts -----------------------------------------------

ex_walnut_ha = FunZone_sum(rast_walnut_ha)
ex_almond_ha = FunZone_sum(rast_almond_ha)
ex_chestnut_ha = FunZone_sum(rast_chestnut_ha)
ex_cashew_ha = FunZone_sum(rast_cashew_ha)
ex_pistachio_ha = FunZone_sum(rast_pistachio_ha)
ex_kolanut_ha = FunZone_sum(rast_kolanut_ha)
ex_hazelnut_ha = FunZone_sum(rast_hazelnut_ha)
ex_brazil_ha = FunZone_sum(rast_brazil_ha)
ex_areca_ha = FunZone_sum(rast_areca_ha)
ex_nutnes_ha = FunZone_sum(rast_nutnes_ha)

# Rest
ex_anise_ha = FunZone_sum(rast_anise_ha)
ex_chili_ha = FunZone_sum(rast_chili_ha)
ex_cinnamon_ha =FunZone_sum(rast_cinnamon_ha) 
ex_ginger_ha = FunZone_sum(rast_ginger_ha)
ex_hop_ha = FunZone_sum(rast_hop_ha)
ex_mate_ha = FunZone_sum(rast_mate_ha)
ex_nutmeg_ha = FunZone_sum(rast_nutmeg_ha)
ex_pepper_ha = FunZone_sum(rast_pepper_ha)
ex_peppermint_ha = FunZone_sum(rast_peppermint_ha)
ex_pyreth_ha = FunZone_sum(rast_pyreth_ha)
ex_ramie_ha = FunZone_sum(rast_ramie_ha)
ex_ruber_ha = FunZone_sum(rast_ruber_ha)
ex_spices_ha = FunZone_sum(rast_spices_ha)
ex_sugarnes_ha = FunZone_sum(rast_sugarnes_ha)
ex_vanilla_ha = FunZone_sum(rast_vanilla_ha)
  
# list all treenuts
lst.ex.ha = list(ex_walnut_ha,ex_almond_ha,ex_chestnut_ha,ex_cashew_ha,ex_pistachio_ha, ex_kolanut_ha, ex_hazelnut_ha, ex_areca_ha, ex_nut_ha,
                 ex_anise_ha, ex_chili_ha, ex_cinnamon_ha, ex_ginger_ha, ex_hop_ha, ex_mate_ha, ex_nutmeg_ha, ex_pepper_ha, ex_peppermint_ha, ex_pyreth_ha, ex_ramie_ha, ex_ruber_ha, ex_spices_ha, ex_sugarnes_ha, ex_vanilla_ha)
dat_ex.ha = do.call("cbind", lst.ex.ha) # merging all tech types

# list rest

treenut_ha = dat_ex.ha %>% 
  select(UID, GID_0,GID_1,sum.walnut_HarvestedAreaHectares, 
         sum.almond_HarvestedAreaHectares,
         sum.chestnut_HarvestedAreaHectares,
         sum.cashew_HarvestedAreaHectares,
         sum.pistachio_HarvestedAreaHectares,
         sum.kolanut_HarvestedAreaHectares,
         sum.hazelnut_HarvestedAreaHectares, 
         geometry) %>% 
  mutate(treenut_ha = sum(sum.walnut_HarvestedAreaHectares, 
         sum.almond_HarvestedAreaHectares,
         sum.chestnut_HarvestedAreaHectares,
         sum.cashew_HarvestedAreaHectares,
         sum.pistachio_HarvestedAreaHectares,
         sum.kolanut_HarvestedAreaHectares,
         sum.hazelnut_HarvestedAreaHectares)) %>% 
  mutate(rest_ha = sum(sum.aniseetc_HarvestedAreaHectares,
                       sum.chilleetc_HarvestedAreaHectares,
                       sum.cinnamon_HarvestedAreaHectares,
                       sum.ginger_HarvestedAreaHectares,
                       sum.hop_HarvestedAreaHectares,
                       sum.mate_HarvestedAreaHectares, 
                       sum.nutmeg_HarvestedAreaHectares,
                       sum.pepper_HarvestedAreaHectares,
                       sum.peppermint_HarvestedAreaHectares,
                       sum.pyrethrum_HarvestedAreaHectares,
                       sum.ramie_HarvestedAreaHectares,
                       sum.rubber_HarvestedAreaHectares,
                       sum.spicenes_HarvestedAreaHectares,
                       sum.sugarnes_HarvestedAreaHectares,
                       sum.vanilla_HarvestedAreaHectares))

# class(treenut_yld)
# write.csv(treenut_yld, 'D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/Treenuts', row.names=T) 
st_write(treenut_ha, "D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/Treenuts/GADM_treenut_rest_ha.shp", driver="ESRI Shapefile")  # create to a shapefile 



# Loading the files and calculate final ratio -----------------------------
wd2=setwd("D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/Treenuts")

sph.prod = read_sf(dsn = wd2, layer = "GADM_treenut_rest_pd")
sph.harv = read_sf(dsn = wd2, layer = "GADM_treenut_rest_ha")

join_harv = st_join(SPAM_GADM_JOIN_GIS_left, sph.harv, join = st_intersects)
join_harv_prod_SPAM_GADM = st_join(join_harv, sph.prod, join = st_intersects)



# Joining GADM with SPAM -------------------------------------------------------
library(sf)
library(raster)
library(sp) 
library(dplyr)
library(spatialEco)
library(exactextractr)
library(sp)
library(tibble)

wd=setwd("C:/Users/molch/OneDrive - Wageningen University & Research/PhD_WJS/Academic/RQ1/Data_analysis/Raw_dat/Zonation/GADM/gadm36_shp")

# Load and check shapefile 
shape=read_sf(dsn = wd, layer = "gadm36") # multipolygons containing all admin levels globally
shape=dplyr::select(shape, 'UID', 'geometry', 'GID_0', 'GID_1')
# shape_fil=filter(shape, GID_0 == 'FIN')

# Making SPAM spatial explicit 
library(readr)
dat_spam=read_csv("C:/Users/molch/OneDrive - Wageningen University & Research/PhD_WJS/Academic/RQ1/Data_analysis/Raw_dat/Zonation/SPAM/2010/spam2010v2r0_global_yield.csv/spam2010V2r0_global_Y_TA.csv")
dat_spam=dplyr::select(dat_spam, 'x','y', 'alloc_key')

# Make SPAM spatial 
projcrs <- "+proj=longlat +datum=WGS84 +no_defs +ellps=WGS84 +towgs84=0,0,0"
dat_cent <- st_as_sf(x = dat_spam,                         
                     coords = c("x", "y"),
                     crs = projcrs)

class(dat_cent)
# dat_cent = filter(df, iso3=="FIN")


SPAM_GADM_JOIN_GIS_left = st_join(dat_cent, shape, join = st_intersects, left = T) #https://postgis.net/docs/ST_Within.html 
head(SPAM_GADM_JOIN_GIS)
class(SPAM_GADM_Join)

st_write(obj = SPAM_GADM_JOIN_GIS, dsn = "C:/Users/molch/OneDrive - Wageningen University & Research/PhD_WJS/Academic/RQ1/Data_analysis/Spatial_mod/Modified_scripts/R/Cifos_Crop_Codule/Treenuts", driver = "ESRI Shapefile")
st_write(obj = SPAM_GADM_JOIN_GIS_left, dsn = "C:/Users/molch/OneDrive - Wageningen University & Research/PhD_WJS/Academic/RQ1/Data_analysis/Spatial_mod/Modified_scripts/R/Cifos_Crop_Codule/Treenuts/GADM_lengthSPAM", driver = "ESRI Shapefile")



# Aggregating values for Adm1 level (https://geocompr.robinlovelace.net/attr.html) 
# TODO: Adjust
world_agg3 = world %>%
  group_by(continent) %>%
  summarize(pop = sum(pop, na.rm = TRUE))
#> `summarise()` ungrouping output (override with `.groups` argument)

# Summarize all the crops to Totaltreenuts
# 


ex_walnut_ha=FunZone_ha(rast_walnut_ha)
ex_almond_ha=FunZone_ha(rast_almond_ha)
ex_chestnut_ha=FunZone_ha(rast_chestnut_ha)
ex_cashew_ha=FunZone_ha(rast_cashew_ha)
ex_pistachio_ha=FunZone_ha(rast_pistachio_ha)
ex_kolanut_ha=FunZone_ha(rast_kolanut_ha)
ex_hazelnut_ha=FunZone_ha(rast_hazelnut_ha)

FunZone_yld(rast_almond_yld)
lapply(yld_list, FunZone_yld)


# Others ------------------------------------------------------------------


cent_mean_FIN <- raster::extract(rast,        # raster layer
                                 ds,   #           #  SF with centroids for buffer
                                 buffer = 5000,   # buffer size, units depend on CRS. Here in meters.10x10km(~5km radius)
                                 fun=mean,         # what value to extract
                                 df=TRUE)          # creating a df TRUE





# Garbage -----------------------------------------------------------------

# rastlist_yld <- list.files(path = "D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/GeoTiff/TreeNuts_Others", 
#                            pattern='.tif',
#                            all.files=TRUE,
#                            full.names=FALSE)
# 
# #import all raster files in folder using lapply
# lapply(rastlist_yld, raster)
# 
# #to check the index numbers of all imported raster list elements
# allrasters
# 
# #call single raster element
# allrasters[[1]]
# 
# #to run a function on an individual raster e.g., plot 
# plot(allrasters[[1]])
# 
# 
# # Perform zonal statistics ------------------------------------------------
# FunZone=function(rast, shape){ # raster and vector
#   c=zonal.stats(shape, d, stats = c("mean")) 
#   c$UID <- shape$UID  # assigning the identifier of the original df to the extracted df
#   dat <- merge(shape, c, by.x = 'UID', by.y = 'UID') # merge the two files togethere
# }

