easypackages::packages(c("tidyverse", 'sf', 'raster','sp','dplyr','spatialEco',
                         'exactextractr','tibble', 'here', "readr", "margrittr","tydr",
                         "readxl", "sfheaders"))

# New approach  -----------------------------------------------------------
# Idea: 
# 1. Load all the harvested area and yields (GeoTIFF) 
# 2. Extract to point of the Spam cells
# 3.       
# 4. Then look at the proportion between Treenuts and the rest of spam crop others for each pixel

# Zonal statistics  -------------------------------------------------------
wd=setwd(here("Input_data"))

# Load and check shapefile 
shape_gadm=read_sf(dsn = wd, layer = "gadm36") # multipolygons containing all admin levels globally
shape_gadm=dplyr::select(shape_gadm, 'UID', 'geometry', 'GID_0', 'GID_1')

shape_gaul=read_sf(here("Input_data", "g2008_1.shp")) #actual GAUL map 
shape_gaul=dplyr::select(shape_gaul, 'G2008_1_ID',  'ADM1_CODE', "ADM0_CODE", 'ADM0_NAME', 'ADM1_NAME', "CONTINENT", "REGION", "geometry")
class(shape_gadm)
# shape_fil=filter(shape, GID_0 == 'FIN')


# Load treenuts and rest files 
{
# ylds - Nuts
rast_walnut_yld = raster(here("Input_data","walnut_YieldPerHectare.tif"))
{
# class(rast_walnut_yld)

# rast_walnut_withoutNA = rast_walnut_yld
# # 
# mean(rast_walnut_yld$walnut_YieldPerHectare)
# mean(rast_walnut_withoutNA$walnut_YieldPerHectare)
# rast_walnut_withoutNA[rast_walnut_withoutNA$walnut_YieldPerHectare == 0] <- NA
# check=as.raster(rast_walnut_withoutNA)
# 
# cellStats(rast_walnut_withoutNA$walnut_YieldPerHectare, mean)
# 
# cellStats(rast_walnut_withoutNA, mean)
# cellStats(rast_walnut_yld, mean)
# rast_walnut_withoutNA$walnut_YieldPerHectare
}
rast_almond_yld = raster(here("Input_data","almond_YieldPerHectare.tif"))
rast_chestnut_yld = raster(here("Input_data","chestnut_YieldPerHectare.tif"))
rast_cashew_yld = raster(here("Input_data","cashew_YieldPerHectare.tif"))
rast_pistachio_yld = raster(here("Input_data","pistachio_YieldPerHectare.tif"))
rast_kolanut_yld = raster(here("Input_data", "kolanut_YieldPerHectare.tif"))
rast_hazelnut_yld = raster(here("Input_data","hazelnut_YieldPerHectare.tif"))
rast_brazil_yld = raster(here("Input_data","brazil_YieldPerHectare.tif"))
rast_areca_yld = raster(here("Input_data","areca_YieldPerHectare.tif"))
rast_nutnes_yld  = raster(here("Input_data","nutnes_YieldPerHectare.tif"))
{
# 0's to Na's
# rast_almond_yldNA=rast_almond_yld[rast_almond_yld$almond_YieldPerHectare == 0] <- NA

# rast_almond_yld[rast_almond_yld$almond_YieldPerHectare == 0] <- NA

# cellStats(rast_walnut_withoutNA$walnut_YieldPerHectare, min)
# cellStats(rast_walnut_yld$walnut_YieldPerHectare, min)

# rast_almond_yld
}
# yld - Rest
rast_anise_yld = raster(here("Input_data","aniseetc_YieldPerHectare.tif"))
rast_chili_yld = raster(here("Input_data","chilleetc_YieldPerHectare.tif"))
rast_cinnamon_yld = raster(here("Input_data","cinnamon_YieldPerHectare.tif"))
rast_ginger_yld = raster(here("Input_data",'ginger_YieldPerHectare.tif'))
rast_hop_yld = raster(here("Input_data",'hop_YieldPerHectare.tif'))
rast_mate_yld = raster(here("Input_data",'mate_YieldPerHectare.tif'))
rast_nutmeg_yld = raster(here("Input_data","nutmeg_YieldPerHectare.tif"))
rast_pepper_yld = raster(here("Input_data",'pepper_YieldPerHectare.tif'))
rast_peppermint_yld = raster(here("Input_data",'peppermint_YieldPerHectare.tif'))
rast_pyreth_yld = raster(here("Input_data",'pyrethrum_YieldPerHectare.tif'))
rast_ramie_yld = raster(here("Input_data",'ramie_YieldPerHectare.tif'))
rast_ruber_yld = raster(here("Input_data",'rubber_YieldPerHectare.tif'))
rast_spices_yld = raster(here("Input_data",'spicenes_YieldPerHectare.tif'))
rast_sugarnes_yld = raster(here("Input_data",'sugarnes_YieldPerHectare.tif'))
rast_vanilla_yld = raster(here("Input_data",'vanilla_YieldPerHectare.tif'))

# Production - treenuts

rast_walnut_pd = raster(here("Input_data","walnut_Production.tif"))
rast_almond_pd = raster(here("Input_data","almond_Production.tif"))
rast_chestnut_pd = raster(here("Input_data","chestnut_Production.tif"))
rast_cashew_pd = raster(here("Input_data","cashew_Production.tif"))
rast_pistachio_pd = raster(here("Input_data","pistachio_Production.tif"))
rast_kolanut_pd = raster(here("Input_data", "kolanut_Production.tif"))
rast_hazelnut_pd = raster(here("Input_data","hazelnut_Production.tif"))
rast_brazil_pd = raster(here("Input_data","brazil_Production.tif"))
rast_areca_pd = raster(here("Input_data","areca_Production.tif"))
rast_nutnes_pd  = raster(here("Input_data","nutnes_Production.tif"))
# Production  -rest
rast_anise_pd = raster(here("Input_data","aniseetc_Production.tif"))
rast_chili_pd = raster(here("Input_data","chilleetc_Production.tif"))
rast_cinnamon_pd = raster(here("Input_data","cinnamon_Production.tif"))
rast_ginger_pd = raster(here("Input_data",'ginger_Production.tif'))
rast_hop_pd = raster(here("Input_data",'hop_Production.tif'))
rast_mate_pd = raster(here("Input_data",'mate_Production.tif'))
rast_nutmeg_pd = raster(here("Input_data","nutmeg_Production.tif"))
rast_pepper_pd = raster(here("Input_data",'pepper_Production.tif'))
rast_peppermint_pd = raster(here("Input_data",'peppermint_Production.tif'))
rast_pyreth_pd = raster(here("Input_data",'pyrethrum_Production.tif'))
rast_ramie_pd = raster(here("Input_data",'ramie_Production.tif'))
rast_ruber_pd = raster(here("Input_data",'rubber_Production.tif'))
rast_spices_pd = raster(here("Input_data",'spicenes_Production.tif'))
rast_sugarnes_pd = raster(here("Input_data",'sugarnes_Production.tif'))
rast_vanilla_pd = raster(here("Input_data",'vanilla_Production.tif'))


# harvested area - treentus 
rast_walnut_ha = raster(here("Input_data","walnut_HarvestedAreaHectares.tif"))
rast_almond_ha = raster(here("Input_data","almond_HarvestedAreaHectares.tif"))
rast_chestnut_ha = raster(here("Input_data","chestnut_HarvestedAreaHectares.tif"))
rast_cashew_ha = raster(here("Input_data","cashew_HarvestedAreaHectares.tif"))
rast_pistachio_ha = raster(here("Input_data","pistachio_HarvestedAreaHectares.tif"))
rast_kolanut_ha = raster(here("Input_data", "kolanut_HarvestedAreaHectares.tif"))
rast_hazelnut_ha = raster(here("Input_data","hazelnut_HarvestedAreaHectares.tif"))
rast_brazil_ha = raster(here("Input_data","brazil_HarvestedAreaHectares.tif"))
rast_areca_ha = raster(here("Input_data","areca_HarvestedAreaHectares.tif"))
rast_nutnes_ha  = raster(here("Input_data","nutnes_HarvestedAreaHectares.tif"))
# HarvestedAreaHectares  -rest
rast_anise_ha = raster(here("Input_data","aniseetc_HarvestedAreaHectares.tif"))
rast_chili_ha = raster(here("Input_data","chilleetc_HarvestedAreaHectares.tif"))
rast_cinnamon_ha = raster(here("Input_data","cinnamon_HarvestedAreaHectares.tif"))
rast_ginger_ha = raster(here("Input_data",'ginger_HarvestedAreaHectares.tif'))
rast_hop_ha = raster(here("Input_data",'hop_HarvestedAreaHectares.tif'))
rast_mate_ha = raster(here("Input_data",'mate_HarvestedAreaHectares.tif'))
rast_nutmeg_ha = raster(here("Input_data","nutmeg_HarvestedAreaHectares.tif"))
rast_pepper_ha = raster(here("Input_data",'pepper_HarvestedAreaHectares.tif'))
rast_peppermint_ha = raster(here("Input_data",'peppermint_HarvestedAreaHectares.tif'))
rast_pyreth_ha = raster(here("Input_data",'pyrethrum_HarvestedAreaHectares.tif'))
rast_ramie_ha = raster(here("Input_data",'ramie_HarvestedAreaHectares.tif'))
rast_ruber_ha = raster(here("Input_data",'rubber_HarvestedAreaHectares.tif'))
rast_spices_ha = raster(here("Input_data",'spicenes_HarvestedAreaHectares.tif'))
rast_sugarnes_ha = raster(here("Input_data",'sugarnes_HarvestedAreaHectares.tif'))
rast_vanilla_ha = raster(here("Input_data",'vanilla_HarvestedAreaHectares.tif'))
}

# yld_list=list(rast_almond_yld, rast_cashew_yld, rast_chestnut_yld, rast_hazelnut_yld, rast_kolanut_yld, rast_pistachio_yld, rast_walnut_yld)
# stack_yld=stack(rast_almond_yld, rast_cashew_yld, rast_chestnut_yld, rast_hazelnut_yld, rast_kolanut_yld, rast_pistachio_yld, rast_walnut_yld)
# stack_ha=stack(rast_almond_ha, rast_cashew_ha, rast_chestnut_ha, rast_hazelnut_ha, rast_kolanut_ha, rast_pistachio_ha, rast_walnut_ha)
# 
# dat$mean.nfertilizer_global
# summary(dat$mean.nfertilizer_global)
# 

# Perform zonal statistics ------------------------------------------------
# FunZone_yld=function(rast,shape, na.rm=T){ # raster and vector
#   c=zonal.stats(shape, rast, stats = c("Fun_nzmean")) 
#   c$UID <- shape$UID  # assigning the identifier of the original df to the extracted df
#   merge(shape, c, by.x = 'UID', by.y = 'UID') # merge the two files together
# }
# GADM
FunZone_sum=function(rast){ # raster and vector
  c=zonal.stats(shape, rast, stats = c("sum")) 
  c$UID <- shape$UID  # assigning the identifier of the original df to the extracted df
  dat <- merge(shape, c, by.x = 'UID', by.y = 'UID') # merge the two files together
}

# GAUL
FunZone_sum=function(rast){ # raster and vector
  c=zonal.stats(shape_gaul, rast, stats = c("sum")) 
  c$G2008_1_ID <- shape_gaul$G2008_1_ID  # assigning the identifier of the original df to the extracted df
  dat <- merge(shape_gaul, c, by.x = 'G2008_1_ID', by.y = 'G2008_1_ID') # merge the two files together
}

# 
# original ----------------------------------------------------------------
FunZone=function(rast, shape, na.rm=T){ # raster and vector
  c=zonal.stats(shape, rast, stats = c("mean"))
  c$UID <- shape$UID  # assigning the identifier of the original df to the extracted df
  dat <- merge(shape, c, by.x = 'UID', by.y = 'UID') # merge the two files togethere
}

# # test ignoring 0s --------------------------------------------------------
# nzmean <- function(x) {
#   zvals <- x==0
#   if (all(zvals)) 0 else mean(x[!zvals])
# }
# 
# Fun_nzmean=function(r, na.rm=F){
#   mean(r[r!=0])
#   }
# 
# FunZone_yld_0=function(rast,shape){ # raster and vector
#   c=zonal.stats(shape, rast, stats = c("nzmean")) 
#   c$UID <- shape$UID  # assigning the identifier of the original df to the extracted df
#   merge(shape, c, by.x = 'UID', by.y = 'UID') # merge the two files together
# }
# 
# # Test raster 
# v2=raster::extract(rast_walnut_yld,shape_fil,fun='Fun_nzmean')


# Yields ------------------------------------------------------------------
# Apply zonal stats to treenuts 
ex_walnut_yld = FunZone_yld(rast_walnut_yld,shape_fil)
ex_walnut_yld_0 = FunZone_yld(rast_walnut_yld,shape_fil)

mean(ex_walnut_yld$mean.walnut_YieldPerHectare)
mean(ex_walnut_yld_0$mean.walnut_YieldPerHectare)
mean(ex_walnut_withNA_FIn$mean.walnut_YieldPerHectare)

ex_walnut_withNA_FIn = FunZone_yld(rast_walnut_withoutNA,shape_fil)
ex_walnut_yld$nzmean.walnut_YieldPerHectare
max(ex_walnut_withNA_FIn$mean.walnut_YieldPerHectare)


ex_almond_yld = FunZone_yld(rast_almond_yld)
ex_chestnut_yld = FunZone_yld(rast_chestnut_yld)
ex_cashew_yld = FunZone_yld(rast_cashew_yld)
ex_pistachio_yld = FunZone_yld(rast_pistachio_yld)
ex_kolanut_yld = FunZone_yld(rast_kolanut_yld)
ex_hazelnut_yld = FunZone_yld(rast_hazelnut_yld)
ex_brazil_yld = FunZone_yld(rast_brazil_yld)
ex_areca_yld = FunZone_yld(rast_areca_yld)
ex_nutnes_yld = FunZone_yld(rast_nutnes_yld)

# Apply zonal stats to rest 
ex_anise_yld = FunZone_yld(rast_anise_yld)
ex_chili_yld = FunZone_yld(rast_chili_yld)
ex_cinnamon_yld =FunZone_yld(rast_cinnamon_yld) 
ex_ginger_yld = FunZone_yld(rast_ginger_yld)
ex_hop_yld = FunZone_yld(rast_hop_yld)
ex_mate_yld = FunZone_yld(rast_mate_yld)
ex_nutmeg_yld = FunZone_yld(rast_nutmeg_yld)
ex_pepper_yld = FunZone_yld(rast_pepper_yld)
ex_peppermint_yld = FunZone_yld(rast_peppermint_yld)
ex_pyreth_yld = FunZone_yld(rast_pyreth_yld)
ex_ramie_yld = FunZone_yld(rast_ramie_yld)
ex_ruber_yld = FunZone_yld(rast_ruber_yld)
ex_spices_yld = FunZone_yld(rast_spices_yld)
ex_sugarnes_yld = FunZone_yld(rast_sugarnes_yld)
ex_vanilla_yld = FunZone_yld(rast_vanilla_yld)

# Join  columns (cbind)
lst.ex.yld = list(ex_walnut_yld,ex_almond_yld,ex_chestnut_yld,ex_cashew_yld,ex_pistachio_yld, ex_kolanut_yld, ex_hazelnut_yld, ex_areca_yld, ex_brazil_yld, ex_nutnes_yld, 
                  ex_anise_yld, ex_chili_yld, ex_cinnamon_yld, ex_ginger_yld, ex_hop_yld, ex_mate_yld, ex_nutmeg_yld, ex_pepper_yld, ex_peppermint_yld, ex_pyreth_yld, ex_ramie_yld, ex_ruber_yld, ex_spices_yld, ex_sugarnes_yld, ex_vanilla_yld)
dat_ex.yld = do.call("cbind", lst.ex.yld) # merging all tech types
# head(dat_ex.yld)

treenut_yld = dat_ex.yld %>% 
  select(UID, GID_0,GID_1,mean.walnut_YieldPerHectare, 
       mean.almond_YieldPerHectare,
       mean.chestnut_YieldPerHectare,
       mean.cashew_YieldPerHectare,
       mean.pistachio_YieldPerHectare,
       mean.kolanut_YieldPerHectare,
       mean.hazelnut_YieldPerHectare, 
       mean.areca_YieldPerHectare, 
       mean.brazil_YieldPerHectare, 
       mean.nutnes_YieldPerHectare, 
       geometry) %>% 
  rowwise()%>%
  mutate(treenut_yld= rowmean(c_across(mean.almond_YieldPerHectare:mean.areca_YieldPerHectare)))%>%
  mutate(treenut_yld= rowmean(c_across(mean.anise_YieldPerHectare:mean.vanilla_YieldPerHectare)))
  
  
# class(treenut_yld)
# write.csv(treenut_yld, 'D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/Treenuts', row.names=T) 
st_write(treenut_yld, here("Input_data", "GADM_treenut.shp"), driver="ESRI Shapefile")  # create to a shapefile 


# Production  -------------------------------------------------------------

ex_walnut_pd = FunZone_sum(rast_walnut_pd)
ex_almond_pd = FunZone_sum(rast_almond_pd)
ex_chestnut_pd = FunZone_sum(rast_chestnut_pd)
ex_cashew_pd = FunZone_sum(rast_cashew_pd)
ex_pistachio_pd = FunZone_sum(rast_pistachio_pd)
ex_kolanut_pd = FunZone_sum(rast_kolanut_pd)
ex_hazelnut_pd = FunZone_sum(rast_hazelnut_pd)
ex_brazil_pd = FunZone_sum(rast_brazil_pd)
ex_areca_pd = FunZone_sum(rast_areca_pd)
ex_nutnes_pd = FunZone_sum(rast_nutnes_pd)

# Rest
ex_anise_pd = FunZone_sum(rast_anise_pd)
ex_chili_pd = FunZone_sum(rast_chili_pd)
ex_cinnamon_pd =FunZone_sum(rast_cinnamon_pd) 
ex_ginger_pd = FunZone_sum(rast_ginger_pd)
ex_hop_pd = FunZone_sum(rast_hop_pd)
ex_mate_pd = FunZone_sum(rast_mate_pd)
ex_nutmeg_pd = FunZone_sum(rast_nutmeg_pd)
ex_pepper_pd = FunZone_sum(rast_pepper_pd)
ex_peppermint_pd = FunZone_sum(rast_peppermint_pd)
ex_pyreth_pd = FunZone_sum(rast_pyreth_pd)
ex_ramie_pd = FunZone_sum(rast_ramie_pd)
ex_ruber_pd = FunZone_sum(rast_ruber_pd)
ex_spices_pd = FunZone_sum(rast_spices_pd)
ex_sugarnes_pd = FunZone_sum(rast_sugarnes_pd)
ex_vanilla_pd = FunZone_sum(rast_vanilla_pd)

# list all treenuts
lst.ex.pd = list(ex_walnut_pd,ex_almond_pd,ex_chestnut_pd,ex_cashew_pd,ex_pistachio_pd, ex_kolanut_pd, ex_hazelnut_pd, ex_areca_pd, ex_nut_pd,
                 ex_anise_pd, ex_chili_pd, ex_cinnamon_pd, ex_ginger_pd, ex_hop_pd, ex_mate_pd, ex_nutmeg_pd, ex_pepper_pd, ex_peppermint_pd, ex_pyreth_pd, ex_ramie_pd, ex_ruber_pd, ex_spices_pd, ex_sugarnes_pd, ex_vanilla_pd)
dat_ex.pd = do.call("cbind", lst.ex.pd) # merging all tech types

# list rest

treenut_pd = dat_ex.pd %>% 
  select(UID, GID_0,GID_1,sum.walnut_Production, 
         sum.almond_Production,
         sum.chestnut_Production,
         sum.cashew_Production,
         sum.pistachio_Production,
         sum.kolanut_Production,
         sum.hazelnut_Production, 
         geometry) %>% 
  mutate(treenut_pd= sum(sum.walnut_Production, 
                          sum.almond_Production,
                          sum.chestnut_Production,
                          sum.cashew_Production,
                          sum.pistachio_Production,
                          sum.kolanut_Production,
                          sum.hazelnut_Production))%>%
  mutate(rest_pd = sum(sum.aniseetc_Production,
                       sum.chilleetc_Production,
                       sum.cinnamon_Production,
                       sum.ginger_Production,
                       sum.hop_Production,
                       sum.mate_Production, 
                       sum.nutmeg_Production,
                       sum.pepper_Production,
                       sum.peppermint_Production,
                       sum.pyrethrum_Production,
                       sum.ramie_Production,
                       sum.rubber_Production,
                       sum.spicenes_Production,
                       sum.sugarnes_Production,
                       sum.vanilla_Production))
         
# class(treenut_yld)
# write.csv(treenut_yld, 'D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/Treenuts', row.names=T) 
st_write(treenut_pd, here("Input_data", "GAUL_treenut_rest_pd.shp"), driver="ESRI Shapefile")  # create to a shapefile

# Harvested area - Treenuts -----------------------------------------------

ex_walnut_ha = FunZone_sum(rast_walnut_ha)
ex_almond_ha = FunZone_sum(rast_almond_ha)
ex_chestnut_ha = FunZone_sum(rast_chestnut_ha)
ex_cashew_ha = FunZone_sum(rast_cashew_ha)
ex_pistachio_ha = FunZone_sum(rast_pistachio_ha)
ex_kolanut_ha = FunZone_sum(rast_kolanut_ha)
ex_hazelnut_ha = FunZone_sum(rast_hazelnut_ha)
ex_brazil_ha = FunZone_sum(rast_brazil_ha)
ex_areca_ha = FunZone_sum(rast_areca_ha)
ex_nutnes_ha = FunZone_sum(rast_nutnes_ha)

# Rest
ex_anise_ha = FunZone_sum(rast_anise_ha)
ex_chili_ha = FunZone_sum(rast_chili_ha)
ex_cinnamon_ha =FunZone_sum(rast_cinnamon_ha) 
ex_ginger_ha = FunZone_sum(rast_ginger_ha)
ex_hop_ha = FunZone_sum(rast_hop_ha)
ex_mate_ha = FunZone_sum(rast_mate_ha)
ex_nutmeg_ha = FunZone_sum(rast_nutmeg_ha)
ex_pepper_ha = FunZone_sum(rast_pepper_ha)
ex_peppermint_ha = FunZone_sum(rast_peppermint_ha)
ex_pyreth_ha = FunZone_sum(rast_pyreth_ha)
ex_ramie_ha = FunZone_sum(rast_ramie_ha)
ex_ruber_ha = FunZone_sum(rast_ruber_ha)
ex_spices_ha = FunZone_sum(rast_spices_ha)
ex_sugarnes_ha = FunZone_sum(rast_sugarnes_ha)
ex_vanilla_ha = FunZone_sum(rast_vanilla_ha)
  
# list all treenuts
lst.ex.ha = list(ex_walnut_ha,ex_almond_ha,ex_chestnut_ha,ex_cashew_ha,ex_pistachio_ha, ex_kolanut_ha, ex_hazelnut_ha, ex_areca_ha, ex_nut_ha,
                 ex_anise_ha, ex_chili_ha, ex_cinnamon_ha, ex_ginger_ha, ex_hop_ha, ex_mate_ha, ex_nutmeg_ha, ex_pepper_ha, ex_peppermint_ha, ex_pyreth_ha, ex_ramie_ha, ex_ruber_ha, ex_spices_ha, ex_sugarnes_ha, ex_vanilla_ha)
dat_ex.ha = do.call("cbind", lst.ex.ha) # merging all tech types

# list rest

treenut_ha = dat_ex.ha %>% 
  select(UID, GID_0,GID_1,sum.walnut_HarvestedAreaHectares, 
         sum.almond_HarvestedAreaHectares,
         sum.chestnut_HarvestedAreaHectares,
         sum.cashew_HarvestedAreaHectares,
         sum.pistachio_HarvestedAreaHectares,
         sum.kolanut_HarvestedAreaHectares,
         sum.hazelnut_HarvestedAreaHectares, 
         geometry) %>% 
  mutate(treenut_ha = sum(sum.walnut_HarvestedAreaHectares, 
         sum.almond_HarvestedAreaHectares,
         sum.chestnut_HarvestedAreaHectares,
         sum.cashew_HarvestedAreaHectares,
         sum.pistachio_HarvestedAreaHectares,
         sum.kolanut_HarvestedAreaHectares,
         sum.hazelnut_HarvestedAreaHectares)) %>% 
  mutate(rest_ha = sum(sum.aniseetc_HarvestedAreaHectares,
                       sum.chilleetc_HarvestedAreaHectares,
                       sum.cinnamon_HarvestedAreaHectares,
                       sum.ginger_HarvestedAreaHectares,
                       sum.hop_HarvestedAreaHectares,
                       sum.mate_HarvestedAreaHectares, 
                       sum.nutmeg_HarvestedAreaHectares,
                       sum.pepper_HarvestedAreaHectares,
                       sum.peppermint_HarvestedAreaHectares,
                       sum.pyrethrum_HarvestedAreaHectares,
                       sum.ramie_HarvestedAreaHectares,
                       sum.rubber_HarvestedAreaHectares,
                       sum.spicenes_HarvestedAreaHectares,
                       sum.sugarnes_HarvestedAreaHectares,
                       sum.vanilla_HarvestedAreaHectares))

st_write(treenut_ha, here("Input_data", "GAUL_treenut_rest_ha.shp"), driver="ESRI Shapefile")  # create to a shapefi


# Loading the files and calculate final ratio -----------------------------
wd2=setwd(here("Input_data"))

sph.prod1 = read_sf(dsn = wd2, layer = "GADM_treenut_rest_pd")
sph.harv1 = read_sf(dsn = wd2, layer = "GADM_treenut_rest_ha")
sph.all = st_join(sph.prod, sph.harv, join = st_within)
write_sf(sph.all, dsn = here("Input_data"), driver = "ESRI Shapefile") #shapefile is called 'Input_data'

join_harv = st_join(SPAM_GADM_JOIN_GIS_left, sph.harv, join = st_intersects)
join_harv_prod_SPAM_GADM = st_join(join_harv, sph.prod, join = st_intersects)

# Joining GADM with SPAM -------------------------------------------------------
wd=setwd(here("Input_data"))

# Load and check shapefile 
shape=read_sf(dsn = wd, layer = "gadm36") # multipolygons containing all admin levels globally
shape=dplyr::select(shape, 'UID', 'geometry', 'GID_0', 'GID_1')
# shape_fil=filter(shape, GID_0 == 'FIN')

# Making SPAM spatial explicit 
dat_spam=read_csv(here("Input_data", "spam2010V2r0_global_Y_TA.csv"))
dat_spam=dplyr::select(dat_spam, 'x','y', 'alloc_key')

# Make SPAM spatial 
projcrs <- "+proj=longlat +datum=WGS84 +no_defs +ellps=WGS84 +towgs84=0,0,0"
dat_cent <- st_as_sf(x = dat_spam,                         
                     coords = c("x", "y"),
                     crs = projcrs)

class(dat_cent)
# dat_cent = filter(df, iso3=="FIN")


SPAM_GADM_JOIN_GIS_left = st_join(dat_cent, shape, join = st_intersects, left = T) #https://postgis.net/docs/ST_Within.html 
# head(SPAM_GADM_JOIN_GIS)
# class(SPAM_GADM_Join)

st_write(obj = SPAM_GADM_JOIN_GIS, dsn = here("Input_data"), driver = "ESRI Shapefile")
st_write(obj = SPAM_GADM_JOIN_GIS_left, dsn = here("Input_data"), driver = "ESRI Shapefile")

# Joining SPAM and GAUL 


