easypackages::packages(c("tidyverse", 'sf', 'raster','sp','dplyr','spatialEco',
                         'exactextractr','tibble', 'here', "readr", "margrittr","tydr",
                         "readxl", "sfheaders"))

# Zonal statistics  -------------------------------------------------------
wd=setwd(here("Input_data"))
ADM1_SPAM_GGS = st_read(here::here("Input_data", "Core_data",  "ADM1_SPAM2010_GGS_geo.shp"), options = "ENCODING=LATIN2")
shape = ADM1_SPAM_GGS

# shape_gaul=read_sf(here("Input_data", "g2008_1.shp")) #actual GAUL map 
# shape_gaul=dplyr::select(shape_gaul, 'G2008_1_ID',  'ADM1_CODE', "ADM0_CODE", 'ADM0_NAME', 'ADM1_NAME', "CONTINENT", "REGION", "geometry")
# class(shape_gadm)
# shape_fil=filter(shape, GID_0 == 'FIN')
dat_spam= read_csv(here("Input_data", "spam2010V2r0_global_P_TA.csv"), locale = locale(encoding = "LATIN2")) # LATIN2 encoding is used for proper display of nordic and slavic names
dat_spam=dplyr::select(dat_spam, cell5m, x,y, name_adm1, iso3)

# Make SPAM spatial 
# projcrs <- "+proj=longlat +datum=WGS84 +no_defs +ellps=WGS84 +towgs84=0,0,0"
# proj_mercator = "+proj=merc +lon_0=0 +k=1 +x_0=0 +y_0=0 +ellps=WGS84 +datum=WGS84 +units=m +no_defs"
proj = "+proj=longlat +datum=WGS84 +no_defs +units=m" # taken from raster file below 
proj_meter = "+datum=WGS84 +units=m +no_defs"
dat_cent <- st_as_sf(x = dat_spam,                         
                     coords = c("x", "y"),
                     crs = proj)


# Load treenuts and rest files 
# {
#   # ylds - Nuts
#   rast_walnut_yld = raster(here("Input_data","walnut_YieldPerHectare.tif"))
#   {
#     
#     # class(rast_walnut_yld)
#     
#     # rast_walnut_withoutNA = rast_walnut_yld
#     # # 
#     # mean(rast_walnut_yld$walnut_YieldPerHectare)
#     # mean(rast_walnut_withoutNA$walnut_YieldPerHectare)
#     # rast_walnut_withoutNA[rast_walnut_withoutNA$walnut_YieldPerHectare == 0] <- NA
#     # check=as.raster(rast_walnut_withoutNA)
#     # 
#     # cellStats(rast_walnut_withoutNA$walnut_YieldPerHectare, mean)
#     # 
#     # cellStats(rast_walnut_withoutNA, mean)
#     # cellStats(rast_walnut_yld, mean)
#     # rast_walnut_withoutNA$walnut_YieldPerHectare
#   }
#   rast_almond_yld = raster(here("Input_data","almond_YieldPerHectare.tif"))
#   rast_chestnut_yld = raster(here("Input_data","chestnut_YieldPerHectare.tif"))
#   rast_cashew_yld = raster(here("Input_data","cashew_YieldPerHectare.tif"))
#   rast_pistachio_yld = raster(here("Input_data","pistachio_YieldPerHectare.tif"))
#   rast_hazelnut_yld = raster(here("Input_data","hazelnut_YieldPerHectare.tif"))
#   rast_brazil_yld = raster(here("Input_data","brazil_YieldPerHectare.tif"))
#   rast_nutnes_yld  = raster(here("Input_data","nutnes_YieldPerHectare.tif"))
#   {
#     # 0's to Na's
#     # rast_almond_yldNA=rast_almond_yld[rast_almond_yld$almond_YieldPerHectare == 0] <- NA
#     
#     # rast_almond_yld[rast_almond_yld$almond_YieldPerHectare == 0] <- NA
#     
#     # cellStats(rast_walnut_withoutNA$walnut_YieldPerHectare, min)
#     # cellStats(rast_walnut_yld$walnut_YieldPerHectare, min)
#     
#     # rast_almond_yld
#   }
#   # yld - Rest
#   rast_kolanut_yld = raster(here("Input_data", "kolanut_YieldPerHectare.tif"))
#   rast_areca_yld = raster(here("Input_data","areca_YieldPerHectare.tif"))
#   rast_anise_yld = raster(here("Input_data","aniseetc_YieldPerHectare.tif"))
#   rast_chili_yld = raster(here("Input_data","chilleetc_YieldPerHectare.tif"))
#   rast_cinnamon_yld = raster(here("Input_data","cinnamon_YieldPerHectare.tif"))
#   rast_ginger_yld = raster(here("Input_data",'ginger_YieldPerHectare.tif'))
#   rast_hop_yld = raster(here("Input_data",'hop_YieldPerHectare.tif'))
#   rast_mate_yld = raster(here("Input_data",'mate_YieldPerHectare.tif'))
#   rast_nutmeg_yld = raster(here("Input_data","nutmeg_YieldPerHectare.tif"))
#   rast_pepper_yld = raster(here("Input_data",'pepper_YieldPerHectare.tif'))
#   rast_peppermint_yld = raster(here("Input_data",'peppermint_YieldPerHectare.tif'))
#   rast_pyreth_yld = raster(here("Input_data",'pyrethrum_YieldPerHectare.tif'))
#   rast_ramie_yld = raster(here("Input_data",'ramie_YieldPerHectare.tif'))
#   rast_ruber_yld = raster(here("Input_data",'rubber_YieldPerHectare.tif'))
#   rast_spices_yld = raster(here("Input_data",'spicenes_YieldPerHectare.tif'))
#   rast_sugarnes_yld = raster(here("Input_data",'sugarnes_YieldPerHectare.tif'))
#   rast_vanilla_yld = raster(here("Input_data",'vanilla_YieldPerHectare.tif'))
# 
#     
    # Production - treenuts
  
  rast_walnut_pd = raster(here("Input_data","walnut_Production.tif"))
  rast_almond_pd = raster(here("Input_data","almond_Production.tif"))
  rast_chestnut_pd = raster(here("Input_data","chestnut_Production.tif"))
  rast_cashew_pd = raster(here("Input_data","cashew_Production.tif"))
  rast_pistachio_pd = raster(here("Input_data","pistachio_Production.tif"))
  rast_hazelnut_pd = raster(here("Input_data","hazelnut_Production.tif"))
  rast_brazil_pd = raster(here("Input_data","brazil_Production.tif"))
  rast_nutnes_pd  = raster(here("Input_data","nutnes_Production.tif"))
 
   # Production  -rest
  rast_anise_pd = raster(here("Input_data","aniseetc_Production.tif"))
  rast_chili_pd = raster(here("Input_data","chilleetc_Production.tif"))
  rast_cinnamon_pd = raster(here("Input_data","cinnamon_Production.tif"))
  rast_ginger_pd = raster(here("Input_data",'ginger_Production.tif'))
  rast_hop_pd = raster(here("Input_data",'hop_Production.tif'))
  rast_mate_pd = raster(here("Input_data",'mate_Production.tif'))
  rast_nutmeg_pd = raster(here("Input_data","nutmeg_Production.tif"))
  rast_pepper_pd = raster(here("Input_data",'pepper_Production.tif'))
  rast_peppermint_pd = raster(here("Input_data",'peppermint_Production.tif'))
  rast_pyreth_pd = raster(here("Input_data",'pyrethrum_Production.tif'))
  rast_ramie_pd = raster(here("Input_data",'ramie_Production.tif'))
  rast_ruber_pd = raster(here("Input_data",'rubber_Production.tif'))
  rast_spices_pd = raster(here("Input_data",'spicenes_Production.tif'))
  rast_sugarnes_pd = raster(here("Input_data",'sugarnes_Production.tif'))
  rast_vanilla_pd = raster(here("Input_data",'vanilla_Production.tif'))
  rast_kolanut_pd = raster(here("Input_data", "kolanut_Production.tif"))
  rast_areca_pd = raster(here("Input_data","areca_Production.tif"))
  

  # harvested area - treentus 
  rast_walnut_ha = raster(here("Input_data","walnut_HarvestedAreaHectares.tif"))
  rast_almond_ha = raster(here("Input_data","almond_HarvestedAreaHectares.tif"))
  rast_chestnut_ha = raster(here("Input_data","chestnut_HarvestedAreaHectares.tif"))
  rast_cashew_ha = raster(here("Input_data","cashew_HarvestedAreaHectares.tif"))
  rast_pistachio_ha = raster(here("Input_data","pistachio_HarvestedAreaHectares.tif"))
  rast_hazelnut_ha = raster(here("Input_data","hazelnut_HarvestedAreaHectares.tif"))
  rast_brazil_ha = raster(here("Input_data","brazil_HarvestedAreaHectares.tif"))
  rast_nutnes_ha  = raster(here("Input_data","nutnes_HarvestedAreaHectares.tif"))
  
  # HarvestedAreaHectares  -rest
  rast_kolanut_ha = raster(here("Input_data", "kolanut_HarvestedAreaHectares.tif"))
  rast_areca_ha = raster(here("Input_data","areca_HarvestedAreaHectares.tif"))
  rast_anise_ha = raster(here("Input_data","aniseetc_HarvestedAreaHectares.tif"))
  rast_chili_ha = raster(here("Input_data","chilleetc_HarvestedAreaHectares.tif"))
  rast_cinnamon_ha = raster(here("Input_data","cinnamon_HarvestedAreaHectares.tif"))
  rast_ginger_ha = raster(here("Input_data",'ginger_HarvestedAreaHectares.tif'))
  rast_hop_ha = raster(here("Input_data",'hop_HarvestedAreaHectares.tif'))
  rast_mate_ha = raster(here("Input_data",'mate_HarvestedAreaHectares.tif'))
  rast_nutmeg_ha = raster(here("Input_data","nutmeg_HarvestedAreaHectares.tif"))
  rast_pepper_ha = raster(here("Input_data",'pepper_HarvestedAreaHectares.tif'))
  rast_peppermint_ha = raster(here("Input_data",'peppermint_HarvestedAreaHectares.tif'))
  rast_pyreth_ha = raster(here("Input_data",'pyrethrum_HarvestedAreaHectares.tif'))
  rast_ramie_ha = raster(here("Input_data",'ramie_HarvestedAreaHectares.tif'))
  rast_ruber_ha = raster(here("Input_data",'rubber_HarvestedAreaHectares.tif'))
  rast_spices_ha = raster(here("Input_data",'spicenes_HarvestedAreaHectares.tif'))
  rast_sugarnes_ha = raster(here("Input_data",'sugarnes_HarvestedAreaHectares.tif'))
  rast_vanilla_ha = raster(here("Input_data",'vanilla_HarvestedAreaHectares.tif'))
# }

# yld_list=list(rast_almond_yld, rast_cashew_yld, rast_chestnut_yld, rast_hazelnut_yld, rast_kolanut_yld, rast_pistachio_yld, rast_walnut_yld)
# stack_yld=stack(rast_almond_yld, rast_cashew_yld, rast_chestnut_yld, rast_hazelnut_yld, rast_kolanut_yld, rast_pistachio_yld, rast_walnut_yld)
# stack_ha=stack(rast_almond_ha, rast_cashew_ha, rast_chestnut_ha, rast_hazelnut_ha, rast_kolanut_ha, rast_pistachio_ha, rast_walnut_ha)
# 
# dat$mean.nfertilizer_global
# summary(dat$mean.nfertilizer_global)
# 

# Perform zonal statistics ------------------------------------------------
# FunZone_yld=function(rast,shape, na.rm=T){ # raster and vector
#   c=zonal.stats(shape, rast, stats = c("Fun_nzmean")) 
#   c$UID <- shape$UID  # assigning the identifier of the original df to the extracted df
#   merge(shape, c, by.x = 'UID', by.y = 'UID') # merge the two files together
# }
# # GADM
# FunZone_sum=function(rast){ # raster and vector
#   c=zonal.stats(shape, rast, stats = c("sum")) 
#   c$UID <- shape$UID  # assigning the identifier of the original df to the extracted df
#   dat <- merge(shape, c, by.x = 'UID', by.y = 'UID') # merge the two files together
# }

# GGS
FunZone_sum=function(rast){ # raster and vector
  c=zonal.stats(ADM1_SPAM_GGS, rast, stats = c("sum")) 
  c$name_adm1 <- ADM1_SPAM_GGS$name_adm1  # assigning the identifier of the original df to the extracted df
  dat <- merge(ADM1_SPAM_GGS, c, by.x = 'name_adm1', by.y = 'name_adm1') # merge the two files together
}
# 
# # original ----------------------------------------------------------------
# FunZone=function(rast, shape, na.rm=T){ # raster and vector
#   c=zonal.stats(shape, rast, stats = c("mean"))
#   c$UID <- shape$UID  # assigning the identifier of the original df to the extracted df
#   dat <- merge(shape, c, by.x = 'UID', by.y = 'UID') # merge the two files togethere
# }
# ?read_sf
# # test ignoring 0s --------------------------------------------------------
# nzmean <- function(x) {
#   zvals <- x==0
#   if (all(zvals)) 0 else mean(x[!zvals])
# }
# 
# Fun_nzmean=function(r, na.rm=F){
#   mean(r[r!=0])
#   }
# 
# FunZone_yld_0=function(rast,shape){ # raster and vector
#   c=zonal.stats(shape, rast, stats = c("nzmean")) 
#   c$UID <- shape$UID  # assigning the identifier of the original df to the extracted df
#   merge(shape, c, by.x = 'UID', by.y = 'UID') # merge the two files together
# }
# 
# # Test raster 
# v2=raster::extract(rast_walnut_yld,shape_fil,fun='Fun_nzmean')


# # Yields ------------------------------------------------------------------
# # Apply zonal stats to treenuts 
# ex_walnut_yld = FunZone_yld(rast_walnut_yld)
# ex_almond_yld = FunZone_yld(rast_almond_yld)
# ex_chestnut_yld = FunZone_yld(rast_chestnut_yld)
# ex_cashew_yld = FunZone_yld(rast_cashew_yld)
# ex_pistachio_yld = FunZone_yld(rast_pistachio_yld)
# ex_hazelnut_yld = FunZone_yld(rast_hazelnut_yld)
# ex_brazil_yld = FunZone_yld(rast_brazil_yld)
# ex_nutnes_yld = FunZone_yld(rast_nutnes_yld)
# 
# # Apply zonal stats to rest 
# ex_kolanut_yld = FunZone_yld(rast_kolanut_yld)
# ex_areca_yld = FunZone_yld(rast_areca_yld)
# ex_anise_yld = FunZone_yld(rast_anise_yld)
# ex_chili_yld = FunZone_yld(rast_chili_yld)
# ex_cinnamon_yld =FunZone_yld(rast_cinnamon_yld) 
# ex_ginger_yld = FunZone_yld(rast_ginger_yld)
# ex_hop_yld = FunZone_yld(rast_hop_yld)
# ex_mate_yld = FunZone_yld(rast_mate_yld)
# ex_nutmeg_yld = FunZone_yld(rast_nutmeg_yld)
# ex_pepper_yld = FunZone_yld(rast_pepper_yld)
# ex_peppermint_yld = FunZone_yld(rast_peppermint_yld)
# ex_pyreth_yld = FunZone_yld(rast_pyreth_yld)
# ex_ramie_yld = FunZone_yld(rast_ramie_yld) # not there in SPAM
# ex_ruber_yld = FunZone_yld(rast_ruber_yld)
# ex_spices_yld = FunZone_yld(rast_spices_yld)
# ex_sugarnes_yld = FunZone_yld(rast_sugarnes_yld)
# ex_vanilla_yld = FunZone_yld(rast_vanilla_yld)
# 
# # Join  columns (cbind)
# lst.ex.yld = list(ex_walnut_yld,ex_almond_yld,ex_chestnut_yld,ex_cashew_yld,ex_pistachio_yld, ex_hazelnut_yld,  ex_brazil_yld, ex_nutnes_yld, 
#                   ex_areca_yld, ex_kolanut_yld, ex_anise_yld, ex_chili_yld, ex_cinnamon_yld, ex_ginger_yld, ex_hop_yld, ex_mate_yld, ex_nutmeg_yld, ex_pepper_yld, ex_peppermint_yld, ex_pyreth_yld, ex_ramie_yld, ex_ruber_yld, ex_spices_yld, ex_sugarnes_yld, ex_vanilla_yld)
# dat_ex.yld = do.call("cbind", lst.ex.yld) # merging all tech types
# # head(dat_ex.yld)
# 
# treenut_yld = dat_ex.yld %>% 
#   select(UID, GID_0,GID_1,mean.walnut_YieldPerHectare, 
#          mean.almond_YieldPerHectare,
#          mean.chestnut_YieldPerHectare,
#          mean.cashew_YieldPerHectare,
#          mean.pistachio_YieldPerHectare,
#          mean.kolanut_YieldPerHectare,
#          mean.hazelnut_YieldPerHectare, 
#          mean.areca_YieldPerHectare, 
#          mean.brazil_YieldPerHectare, 
#          mean.nutnes_YieldPerHectare, 
#          geometry) %>% 
#   rowwise()%>%
#   mutate(treenut_yld= rowmean(c_across(mean.almond_YieldPerHectare:mean.areca_YieldPerHectare)))%>%
#   mutate(treenut_yld= rowmean(c_across(mean.anise_YieldPerHectare:mean.vanilla_YieldPerHectare)))
# 

# class(treenut_yld)
# write.csv(treenut_yld, 'D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/Treenuts', row.names=T) 
# st_write(treenut_yld, here("Input_data", "GADM_treenut.shp"), driver="ESRI Shapefile")  # create to a shapefile 


# Production  -------------------------------------------------------------
ex_walnut_pd = FunZone_sum(rast_walnut_pd)
ex_almond_pd = FunZone_sum(rast_almond_pd)
ex_chestnut_pd = FunZone_sum(rast_chestnut_pd)
ex_cashew_pd = FunZone_sum(rast_cashew_pd)
ex_pistachio_pd = FunZone_sum(rast_pistachio_pd)
ex_hazelnut_pd = FunZone_sum(rast_hazelnut_pd)
ex_brazil_pd = FunZone_sum(rast_brazil_pd)
ex_nutnes_pd = FunZone_sum(rast_nutnes_pd)

# Rest
ex_areca_pd = FunZone_sum(rast_areca_pd)
ex_kolanut_pd = FunZone_sum(rast_kolanut_pd)
ex_anise_pd = FunZone_sum(rast_anise_pd)
ex_chili_pd = FunZone_sum(rast_chili_pd)
ex_cinnamon_pd =FunZone_sum(rast_cinnamon_pd) 
ex_ginger_pd = FunZone_sum(rast_ginger_pd)
ex_hop_pd = FunZone_sum(rast_hop_pd)
ex_mate_pd = FunZone_sum(rast_mate_pd)
ex_nutmeg_pd = FunZone_sum(rast_nutmeg_pd)
ex_pepper_pd = FunZone_sum(rast_pepper_pd)
ex_peppermint_pd = FunZone_sum(rast_peppermint_pd)
ex_pyreth_pd = FunZone_sum(rast_pyreth_pd)
ex_ramie_pd = FunZone_sum(rast_ramie_pd)
ex_ruber_pd = FunZone_sum(rast_ruber_pd)
ex_spices_pd = FunZone_sum(rast_spices_pd)
ex_sugarnes_pd = FunZone_sum(rast_sugarnes_pd)
ex_vanilla_pd = FunZone_sum(rast_vanilla_pd)

# list all treenuts
lst.ex.pd = list(ex_walnut_pd,ex_almond_pd,ex_chestnut_pd,ex_cashew_pd,ex_pistachio_pd, ex_hazelnut_pd, ex_nutnes_pd, ex_brazil_pd,
                 ex_areca_pd, ex_kolanut_pd, ex_anise_pd, ex_chili_pd, ex_cinnamon_pd, ex_ginger_pd, ex_hop_pd, ex_mate_pd, 
                 ex_nutmeg_pd, ex_pepper_pd, ex_peppermint_pd, ex_pyreth_pd, ex_ramie_pd, ex_ruber_pd, ex_spices_pd, ex_sugarnes_pd, ex_vanilla_pd)
dat_ex.pd = do.call("cbind", lst.ex.pd) # merging all tech types

# list rest

treenut_pd = dat_ex.pd %>% #as_tibble() %>% 
  # dplyr::select(UID, GID_0,GID_1,sum.walnut_Production, 
  # dplyr::select(G2008_1_ID, ADM1_CODE,ADM0_CODE, ADM1_NAME,ADM0_NAME, CONTINENT, REGION,
  dplyr::select(iso3, cell5m , name_adm1 , G2008_1_ ,ADM0_CODE, ADM1_CODE, CONTINENT,
                sum.walnut_Production,   
                sum.almond_Production,
                sum.chestnut_Production,
                sum.cashew_Production,
                sum.pistachio_Production,
                sum.hazelnut_Production,
                sum.brazil_Production,
                sum.nutnes_Production,
                sum.kolanut_Production,
                sum.aniseetc_Production,
                sum.chilleetc_Production,
                sum.cinnamon_Production,
                sum.ginger_Production,
                sum.hop_Production,
                sum.mate_Production, 
                sum.nutmeg_Production,
                sum.pepper_Production,
                sum.peppermint_Production,
                sum.pyrethrum_Production,
                sum.ramie_Production,
                sum.rubber_Production,
                sum.spicenes_Production,
                sum.sugarnes_Production,
                sum.vanilla_Production,
                sum.areca_Production,
                geometry) %>% 
  group_by(iso3, name_adm1) %>% 
  mutate(treenut_pd = sum(sum.walnut_Production, 
                         sum.almond_Production,
                         sum.chestnut_Production,
                         sum.cashew_Production,
                         sum.pistachio_Production,
                         sum.hazelnut_Production,
                         sum.brazil_Production,
                         sum.nutnes_Production)) %>%
  mutate(rest_pd = sum(sum.aniseetc_Production,
                       sum.chilleetc_Production,
                       sum.kolanut_Production,
                       sum.areca_Production,
                       sum.cinnamon_Production,
                       sum.ginger_Production,
                       sum.hop_Production,
                       sum.mate_Production, 
                       sum.nutmeg_Production,
                       sum.pepper_Production,
                       sum.peppermint_Production,
                       sum.pyrethrum_Production,
                       sum.ramie_Production,
                       sum.rubber_Production,
                       sum.spicenes_Production,
                       sum.sugarnes_Production,
                       sum.vanilla_Production)) %>% 
  dplyr::select(iso3, cell5m , name_adm1 , G2008_1_ ,ADM0_CODE, ADM1_CODE, CONTINENT,treenut_pd, rest_pd)


# class(treenut_yld)
# write.csv(treenut_yld, 'D:/Raw_dat/Raw_dat/Ramakutty/HarvestedAreaYield175Crops_Geotiff/HarvestedAreaYield175Crops_Geotiff/Treenuts', row.names=T) 
st_write(treenut_pd, here("Input_data", "GSS_treenut_rest_pd.shp"), driver="ESRI Shapefile")  # create to a shapefile
treenut_pd = read_sf(here("Input_data", "GSS_treenut_rest_pd.shp"))

# Harvested area - Treenuts -----------------------------------------------

ex_walnut_ha = FunZone_sum(rast_walnut_ha)
ex_almond_ha = FunZone_sum(rast_almond_ha)
ex_chestnut_ha = FunZone_sum(rast_chestnut_ha)
ex_cashew_ha = FunZone_sum(rast_cashew_ha)
ex_pistachio_ha = FunZone_sum(rast_pistachio_ha)
ex_hazelnut_ha = FunZone_sum(rast_hazelnut_ha)
ex_brazil_ha = FunZone_sum(rast_brazil_ha)
ex_nutnes_ha = FunZone_sum(rast_nutnes_ha)

# Rest
ex_areca_ha = FunZone_sum(rast_areca_ha)
ex_kolanut_ha = FunZone_sum(rast_kolanut_ha)
ex_anise_ha = FunZone_sum(rast_anise_ha)
ex_chili_ha = FunZone_sum(rast_chili_ha)
ex_cinnamon_ha =FunZone_sum(rast_cinnamon_ha) 
ex_ginger_ha = FunZone_sum(rast_ginger_ha)
ex_hop_ha = FunZone_sum(rast_hop_ha)
ex_mate_ha = FunZone_sum(rast_mate_ha)
ex_nutmeg_ha = FunZone_sum(rast_nutmeg_ha)
ex_pepper_ha = FunZone_sum(rast_pepper_ha)
ex_peppermint_ha = FunZone_sum(rast_peppermint_ha)
ex_pyreth_ha = FunZone_sum(rast_pyreth_ha)
ex_ramie_ha = FunZone_sum(rast_ramie_ha)
ex_ruber_ha = FunZone_sum(rast_ruber_ha)
ex_spices_ha = FunZone_sum(rast_spices_ha)
ex_sugarnes_ha = FunZone_sum(rast_sugarnes_ha)
ex_vanilla_ha = FunZone_sum(rast_vanilla_ha)

# list all treenuts
lst.ex.ha = list(ex_walnut_ha,ex_almond_ha,ex_chestnut_ha,ex_cashew_ha,ex_pistachio_ha, ex_hazelnut_ha, ex_nutnes_ha, ex_brazil_ha,
                 ex_kolanut_ha, ex_areca_ha, ex_nutnes_ha, ex_anise_ha, ex_chili_ha, ex_cinnamon_ha, ex_ginger_ha, ex_hop_ha, ex_mate_ha, 
                 ex_nutmeg_ha, ex_pepper_ha, ex_peppermint_ha, ex_pyreth_ha, ex_ramie_ha, ex_ruber_ha, ex_spices_ha, ex_sugarnes_ha, ex_vanilla_ha)
dat_ex.ha = do.call("cbind", lst.ex.ha) # merging all tech types

# list rest
treenut_ha = dat_ex.ha %>% 
  dplyr::select(iso3, cell5m , name_adm1 , G2008_1_ ,ADM0_CODE, ADM1_CODE, CONTINENT,
                sum.walnut_HarvestedAreaHectares, 
                sum.almond_HarvestedAreaHectares,
                sum.chestnut_HarvestedAreaHectares,
                sum.cashew_HarvestedAreaHectares,
                sum.pistachio_HarvestedAreaHectares,
                sum.hazelnut_HarvestedAreaHectares,
                sum.brazil_HarvestedAreaHectares,
                sum.nutnes_HarvestedAreaHectares,
                sum.kolanut_HarvestedAreaHectares,
                sum.aniseetc_HarvestedAreaHectares,
                sum.chilleetc_HarvestedAreaHectares,
                sum.cinnamon_HarvestedAreaHectares,
                sum.ginger_HarvestedAreaHectares,
                sum.hop_HarvestedAreaHectares,
                sum.mate_HarvestedAreaHectares, 
                sum.nutmeg_HarvestedAreaHectares,
                sum.pepper_HarvestedAreaHectares,
                sum.peppermint_HarvestedAreaHectares,
                sum.pyrethrum_HarvestedAreaHectares,
                sum.ramie_HarvestedAreaHectares,
                sum.rubber_HarvestedAreaHectares,
                sum.spicenes_HarvestedAreaHectares,
                sum.sugarnes_HarvestedAreaHectares,
                sum.vanilla_HarvestedAreaHectares,
                sum.areca_HarvestedAreaHectares,
                geometry) %>% 
  group_by(ADM0_CODE, ADM1_CODE) %>% 
  mutate(treenut_ha = sum(sum.walnut_HarvestedAreaHectares, 
                          sum.almond_HarvestedAreaHectares,
                          sum.chestnut_HarvestedAreaHectares,
                          sum.cashew_HarvestedAreaHectares,
                          sum.pistachio_HarvestedAreaHectares,
                          sum.hazelnut_HarvestedAreaHectares,
                          sum.brazil_HarvestedAreaHectares,
                          sum.nutnes_HarvestedAreaHectares)) %>% 
  mutate(rest_ha = sum(sum.aniseetc_HarvestedAreaHectares,
                       sum.kolanut_HarvestedAreaHectares,
                       sum.areca_HarvestedAreaHectares,
                       sum.chilleetc_HarvestedAreaHectares,
                       sum.cinnamon_HarvestedAreaHectares,
                       sum.ginger_HarvestedAreaHectares,
                       sum.hop_HarvestedAreaHectares,
                       sum.mate_HarvestedAreaHectares, 
                       sum.nutmeg_HarvestedAreaHectares,
                       sum.pepper_HarvestedAreaHectares,
                       sum.peppermint_HarvestedAreaHectares,
                       sum.pyrethrum_HarvestedAreaHectares,
                       sum.ramie_HarvestedAreaHectares,
                       sum.rubber_HarvestedAreaHectares,
                       sum.spicenes_HarvestedAreaHectares,
                       sum.sugarnes_HarvestedAreaHectares,
                       sum.vanilla_HarvestedAreaHectares)) %>% 
  dplyr::select(iso3, cell5m , name_adm1 , G2008_1_ ,ADM0_CODE, ADM1_CODE, CONTINENT, treenut_ha, rest_ha)

st_write(treenut_ha, here("Input_data", "GSS_treenut_rest_ha.shp"), driver="ESRI Shapefile")  # create to a shapefile
treenut_ha = read_sf(here("Input_data", "GSS_treenut_rest_ha.shp"))

# Calculate treenuts ratio and calculate treenuts share from "rest --------

# Load treenut data
treenut_ha = read_sf(here("Input_data", "GSS_treenut_rest_ha.shp"))
treenut_pd = read_sf(here("Input_data", "GSS_treenut_rest_pd.shp"))
# Converting to tibble
sph.prod.tib = treenut_pd %>% as_tibble()
sph.harv.tib = treenut_ha %>% as_tibble()


# Load SPAM files 
prd_dat <- read_csv(here::here("Input_data", "Core_data", "production_all_rec_tech_adm1.csv"), locale = locale(encoding = "LATIN2")) 
phy_dat <- read_csv(here::here("Input_data", "Core_data", "physicalarea_all_rec_tech_adm1.csv"), locale = locale(encoding = "LATIN2"))
har_dat <- read_csv(here::here("Input_data", "Core_data", "harvestedarea_all_rec_tech_adm1.csv"), locale = locale(encoding = "LATIN2"))
# Final global transformed SPAM2010 dataset. This df is in lign with GGS adm1 units.
SPAM_GGS_all = rbind(prd_dat, phy_dat, har_dat) # long format

# Loading spatial SPAM file
dat_spam=read_csv(here("input_data", "spam2010V2r0_global_Y_TA.csv"))
dat_spam=dplyr::select(dat_spam, x,y, alloc_key, name_adm1, iso3, name_cntr)
proj = "+proj=longlat +datum=WGS84 +no_defs +units=m" # taken from raster file below 
dat_cent <- st_as_sf(x = dat_spam,                         
                     coords = c("x", "y"),
                     crs = proj)

# Loading Shapefile GGS
ADM1_SPAM_GGS = st_read(here::here("Input_data", "Core_data",  "ADM1_SPAM2010_GGS_geo.shp"), options = "ENCODING=LATIN2")
ADM1_SPAM_GGS_tib = ADM1_SPAM_GGS %>% as_tibble()


# Aggregate tree nuts to to adm1 unit ---------------------------------------
# Production
prod.tib.adm1 = treenut_pd %>% as_tibble() %>%   
  dplyr::select(iso3, cell5m, name_adm1, G2008_1_ ,ADM0_CODE, ADM1_CODE, CONTINENT, treenut_pd, rest_pd) %>%
  dplyr::group_by(iso3, name_adm1, cell5m) %>% 
  dplyr::summarise(round(across(.cols = c(treenut_pd, rest_pd), .fns = sum),1)) %>%
  
# Harvested area 
harv.tib.adm1 = treenut_ha %>%  as_tibble() %>% 
  dplyr::select(iso3, cell5m, name_adm1, G2008_1_ ,ADM0_CODE, ADM1_CODE, CONTINENT, treenut_ha, rest_ha) %>%
  dplyr::group_by(iso3, name_adm1, cell5m) %>% 
  dplyr::summarise(round(across(.cols = c(treenut_ha, rest_ha), .fns = sum),1))  #rounding is kept as in SPAM2010; 1 decimal!

# Join harvested area and calcluate tree nuts ratio  --------------------------
# Validation: Calulation of tnuts ratio correct! 
join_ha_pd_GGS = prod.tib.adm1 %>%
  group_by(iso3, name_adm1) %>% 
  left_join(., harv.tib.adm1, by="cell5m") %>% 
  rowwise() %>% 
  mutate(tnuts_ratio_pd = treenut_pd/sum(treenut_pd, rest_pd),
         tnuts_ratio_ha = treenut_ha/sum(treenut_ha, rest_ha)) %>%
  mutate_at(vars(tnuts_ratio_ha, tnuts_ratio_pd), ~replace(., is.nan(.), 0)) %>% 
  rename(iso3 = iso3.x,
         name_adm1 = name_adm1.x) %>% 
  dplyr::select(cell5m, tnuts_ratio_pd, tnuts_ratio_ha) 



# Calculation of absolute treenuts and rest numbers  ---------------------------
# Validation: Calculation of te shares is correctly translated to the absolute values! 
dat_spam_tnuts = do.call("rbind", list(har_dat, phy_dat, prd_dat)) %>%
  dplyr::select(iso3, name_adm1, rec_type, tech_type, crop, valu) %>%
  mutate(row = row_number()) %>%
  group_by(row, iso3, name_adm1, rec_type, tech_type) %>%
  pivot_wider(id_cols = c(row),
              names_from = "crop", values_from = "valu") #%>% 
  


mutate(Y = (P*1000/H))%>% #checked for result. We are transforming mt to kg  when multiplying Production by 1000 to get unit kg/ha for yields
  mutate_at(vars(Y), ~replace(., is.nan(.), 0))

# Production
dat_prod = join_ha_pd_GGS %>%  
  right_join(., prd_dat, by="cell5m") %>%
  mutate(tnuts = rest*tnuts_ratio_pd, 
         rest = rest*(1-tnuts_ratio_pd)) #%>%
  dplyr::select(iso3, name_adm1, cell5m, tnuts_prd, rest_prd) 
  # write.csv(here("Input_data", "prod_tnuts_rest_spam_gaul_FINAL1.csv"))

# harvested area 
dat_har = join_ha_pd_GGS %>%  
  full_join(., harv.tib.adm1, by="cell5m") %>%
  mutate(tnuts_har = rest_ha*tnuts_ratio_ha, 
         rest_har = rest_ha*(1-tnuts_ratio_ha)) %>%
  dplyr::select(iso3, name_adm1, cell5m, tnuts_har, rest_har)


# Now join it with the final SPAM2010  ------------------------------------
# Load 
%>% 
  pivot_wider(names_from = rec_type)


dat_harv = harv.tib.adm1 %>%  mutate(tnuts = rest*tnuts_ratio_ha,
                                rest = rest*(1-tnuts_ratio_ha)) %>%
  dplyr::select(-c(tnuts_ratio_ha))%>% 
  write.csv(here("Input_data", "harv_tnuts_rest_spam_gaul_FINAL.csv"))

dat_phys = dat.phys %>%  mutate(tnuts = rest*tnuts_ratio_ha,
                                rest = rest*(1-tnuts_ratio_ha)) %>%
  dplyr::select(-c(tnuts_ratio_ha)) %>%    
  write.csv(here("Input_data", "phys_tnuts_rest_spam_gaul_FINAL.csv"))

# Join treenuts_file and GGS==SPAM2010
Join_tnuts_GGS = ADM1_SPAM_GGS %>%  as_tibble() %>% 
  group_by()


# Aggregate results to adm1 level and calculate ratio between nuts and rest
val_pd = treenut_pd %>% 
  group_by(ADM1_CODE, ADM0_CODE) %>% 
  summarise(sum_pd = sum(treenut_pd, keep = T),
            sum_rest_pd = sum(rest_pd)) 
write_sf(val_pd, here("Input_data", "val_pd.shp"))

val_pd=read_sf(dsn=here("Input_data", "val_pd.shp"))
val_pd=rename(val_pd,ADM1_CODE = ADM1_CO, #when loading the data run rename function
              ADM0_CODE = ADM0_CO, 
              sum_rest_pd = sm_rst_)


val_ha = treenut_ha %>% 
  group_by(ADM1_CODE, ADM0_CODE) %>% 
  summarise(sum_ha = sum(treenut_ha, keep = T),
            sum_rest_ha = sum(rest_ha)) #%>% 
write_sf(val_ha, here("Input_data", "val_ha.shp"))

val_ha=read_sf(here("Input_data", "val_ha.shp"))
val_ha = rename(val_ha,
                ADM1_CODE = ADM1_CO,
                ADM0_CODE = ADM0_CO,
                sum_rest_ha = sm_rst_)


# Join of harvested area and production 
join_ha_pd_gaul = val_pd %>%
  group_by(ADM1_CODE, ADM0_CODE) %>%
  as_tibble() %>% 
  left_join(., val_ha, by="ADM1_CODE") %>% 
  left_join(., shape_gaul, by = "ADM1_CODE") %>% 
  rowwise() %>% 
  mutate(tnuts_ratio_pd = sum_pd/sum(sum_pd, sum_rest_pd),
         tnuts_ratio_ha = sum_ha/sum(sum_ha, sum_rest_ha)) %>% 
  dplyr::select(G2008_1_ID, ADM0_CODE, ADM0_NAME, ADM0_NAME, ADM1_NAME, CONTINENT, REGION,
                sum_pd, sum_rest_pd, sum_ha, sum_rest_ha, tnuts_ratio_pd, tnuts_ratio_ha, geometry) #%>% 
st_write(., here("Input_data", "GAUL_tnuts_rest_ratio_ha_pd"), driver="ESRI Shapefile")  # From here go to script 
join_ha_pd_gaul=read_sf(here("Input_data", "GAUL_tnuts_rest_ratio_ha_pd"))
join_ha_pd_gaul=join_ha_pd_gaul %>% as_tibble() %>%  write_csv(here("Input_data", "join_ha_pd_gaul.csv")) # strange transformation. Creates weired rations in csv file













# Joining SPAM with GAUL L -----------------------------------------------------------
dat_spam=read_csv(here("input_data", "spam2010V2r0_global_Y_TA.csv"))
dat_spam=dplyr::select(dat_spam, x,y, alloc_key, name_adm1, iso3, name_cntr)

# Make SPAM spatial 
# projcrs <- "+proj=longlat +datum=WGS84 +no_defs +ellps=WGS84 +towgs84=0,0,0"
# proj_mercator = "+proj=merc +lon_0=0 +k=1 +x_0=0 +y_0=0 +ellps=WGS84 +datum=WGS84 +units=m +no_defs"
proj = "+proj=longlat +datum=WGS84 +no_defs +units=m" # taken from raster file below 
dat_cent <- st_as_sf(x = dat_spam,                         
                     coords = c("x", "y"),
                     crs = proj)

shape_gaul=read_sf(here("Input_data", "g2008_1.shp")) #actual GAUL map 


# LOAD treenut production and harvested area 
treenut_ha= read_sf(here("Input_data", "GAUL_treenut_rest_ha,shp", "GAUL_treenut_rest_ha.shp"))
treenut_pd= read_sf(here("Input_data", "GAUL_treenut_rest_pd,shp", "GAUL_treenut_rest_pd.shp"))
# write_sf(sph.all, dsn = here("Input_data", driver = "ESRI shapefile"))
sph.prod.tib = treenut_pd %>% 
  as_tibble() %>% 
  dplyr::select(G2008_1_ID, ADM1_CODE, ADM0_CODE, ADM0_NAME, treenut_pd, rest_pd,geometry)

sph.harv = treenut_ha %>% 
  as_tibble() %>% 
  dplyr::select(G2008_1_ID, ADM1_CODE, ADM0_CODE, ADM0_NAME, treenut_ha, rest_ha,geometry)
# loading SPAM-GADM join

# Creating a spatial join between the SPAM (pixel) and GAUL 2008
SPAM_GAUL_JOIN = dat_cent %>% 
  st_join(., shape_gaul, join = st_within, left = T)
st_write(SPAM_GAUL_JOIN, here("Input_data", "GAUL2008_SPAM_LINK"), driver="ESRI Shapefile")  # From here go to script 
SPAM_GAUL_JOIN=read_sf(here("Input_data", "GAUL2008_SPAM_LINK"))

# GAUL aggregation and transformation  ------------------------------------

# Independent -- Merging treenuts with SPAM -------------------------------
# LOAD data from previous step (due to memory overuse)
setwd(here('Input_data', "Rectypes_full_cropspread"))
yld_dat <- read_csv('Yield_full_cropspread.csv')
prd_dat <- read_csv('Production_full_cropspread.csv')
har_dat <- read_csv('Harv_area_spatial_spread_SPAM.csv')
phy_dat <- read_csv('Phys_area_full_cropspread.csv')

# Aggregate results to adm1 level and calculate ratio between nuts and rest
val_pd = treenut_pd %>% 
  group_by(ADM1_CODE, ADM0_CODE) %>% 
  summarise(sum_pd = sum(treenut_pd, keep = T),
            sum_rest_pd = sum(rest_pd)) 
write_sf(val_pd, here("Input_data", "val_pd.shp"))

val_pd=read_sf(dsn=here("Input_data", "val_pd.shp"))
val_pd=rename(val_pd,ADM1_CODE = ADM1_CO, #when loading the data run rename function
              ADM0_CODE = ADM0_CO, 
              sum_rest_pd = sm_rst_)


val_ha = treenut_ha %>% 
  group_by(ADM1_CODE, ADM0_CODE) %>% 
  summarise(sum_ha = sum(treenut_ha, keep = T),
            sum_rest_ha = sum(rest_ha)) #%>% 
write_sf(val_ha, here("Input_data", "val_ha.shp"))

val_ha=read_sf(here("Input_data", "val_ha.shp"))
val_ha = rename(val_ha,
                ADM1_CODE = ADM1_CO,
                ADM0_CODE = ADM0_CO,
                sum_rest_ha = sm_rst_)


# Join of harvested area and production 
join_ha_pd_gaul = val_pd %>%
  group_by(ADM1_CODE, ADM0_CODE) %>%
  as_tibble() %>% 
  left_join(., val_ha, by="ADM1_CODE") %>% 
  left_join(., shape_gaul, by = "ADM1_CODE") %>% 
  rowwise() %>% 
  mutate(tnuts_ratio_pd = sum_pd/sum(sum_pd, sum_rest_pd),
         tnuts_ratio_ha = sum_ha/sum(sum_ha, sum_rest_ha)) %>% 
  dplyr::select(G2008_1_ID, ADM0_CODE, ADM0_NAME, ADM0_NAME, ADM1_NAME, CONTINENT, REGION,
                sum_pd, sum_rest_pd, sum_ha, sum_rest_ha, tnuts_ratio_pd, tnuts_ratio_ha, geometry) #%>% 
st_write(., here("Input_data", "GAUL_tnuts_rest_ratio_ha_pd"), driver="ESRI Shapefile")  # From here go to script 
join_ha_pd_gaul=read_sf(here("Input_data", "GAUL_tnuts_rest_ratio_ha_pd"))
join_ha_pd_gaul=join_ha_pd_gaul %>% as_tibble() %>%  write_csv(here("Input_data", "join_ha_pd_gaul.csv")) # strange transformation. Creates weired rations in csv file

# # Production
# # Join of harvested area and production
# join_pd_gaul = val_pd %>%
#   group_by(ADM1_CODE, ADM0_CODE) %>%
#   as_tibble() %>%
#   # left_join(., val_ha, by="ADM1_CODE") %>%
#   left_join(., shape_gaul, by = "ADM1_CODE") %>%
#   rowwise() %>%
#   mutate(tnuts_ratio_pd = sum_pd/sum(sum_pd, sum_rest_pd)) %>% #,
#          # tnuts_ratio_ha = sum_ha/sum(sum_ha, sum_rest_ha)) %>%
#   dplyr::select(G2008_1_ID, ADM0_CODE.x, ADM0_NAME, ADM0_NAME, ADM1_NAME, CONTINENT, REGION,
#                 sum_pd, sum_rest_pd,
#                 # sum_ha, sum_rest_ha,
#                 tnuts_ratio_pd,
#                 # tnuts_ratio_ha,
#                 geometry.y) %>%
# st_write(., here("Input_data", "GAUL_tnuts_rest_ratio_pd"), driver="ESRI Shapefile")  # From here go to script
# join_pd_gaul=read_sf(here("Input_data", "GAUL_tnuts_rest_ratio_ha_pd"))
# 
# # Harvested area
# join_ha_gaul = val_ha %>%
#   group_by(ADM1_CODE, ADM0_CODE) %>%
#   as_tibble() %>%
#   # left_join(., val_ha, by="ADM1_CODE") %>%
#   left_join(., shape_gaul, by = "ADM1_CODE") %>%
#   rowwise() %>%
#   mutate(
#   # tnuts_ratio_pd = sum_pd/sum(sum_pd, sum_rest_pd),
#          tnuts_ratio_ha = sum_ha/sum(sum_ha, sum_rest_ha)) %>%
#   dplyr::select(G2008_1_ID, ADM0_CODE.x, ADM0_NAME, ADM0_NAME, ADM1_NAME, CONTINENT, REGION,
#                 # sum_pd, sum_rest_pd,
#                 sum_ha, sum_rest_ha,
#                 # tnuts_ratio_pd,
#                 tnuts_ratio_ha, geometry.y)# %>%
#   st_write(., here("Input_data", "GAUL_tnuts_rest_ratio_ha"), driver="ESRI Shapefile")  # From here go to script
# 
# join_ha_gaul=read_sf(here("Input_data", "GAUL_tnuts_rest_ratio_ha_ha"))
# 



# Treenuts GAUL pixel  ---------------------------------------------------------------
# Treenuts are loaded from the treenuts script
# Production
# # rbenchmark::benchmark(
# prod_dat_gaul_spam = SPAM_GAUL_JOIN %>% 
#   as_tibble() %>% 
#   left_join(.,sph.prod.tib, by="G2008_1_ID") %>% 
#   left_join(.,prd_dat, by="alloc_key") #%>% 
#   mutate(tnuts = trnt_r_*rest) %>% 
#   mutate(rest.1 = (1-trnt_r_)*rest) %>% 
#   dplyr::select(alloc_key, UID, GID_0.x, GID_1.x, rec_type, tech_type, unit,
#                 whea:rest, tnuts, rest.1) %>% 
#   write.csv(here("Input_data", "prod_tnuts_spam_gaul.csv"))


# c=read_csv(here("Input_data", "prod_tnuts_spam_gaul.csv"))
# 
# # Approach validation > do the numbers make sense?
# xy=dat_join_prod %>% 
#   group_by(tnuts) %>%
#   top_n(n=10) %>% 
#   dplyr::select(rest, tnuts, rest.1)
# 
# write_csv(dat_join_prod, here("Input_data", "dat_treenut_prod.csv"))
# # st_as_sf()

# Production 
# rbenchmark::benchmark(
# treenut_pd = as_tibble(join_ha_pd_gaul) %>% 
#   rename(G2008_1_ID=G2008_1) %>% 
# left_join(.,as_tibble(SPAM_GAUL_JOIN), by="G2008_1_ID") %>% 
#   right_join(.,prd_dat, by="alloc_key")%>% 
# dplyr::select(alloc_key, G2008_1_ID, ADM1_CODE, ADM1_NAME, ADM0_CODE, ADM0_NAME,
#               name_cntr, name_adm1.x, iso3.x, rec_type, tech_type, unit, whea:rest, tnuts_ratio_pd) %>%
#   rename(
#     # ADM1_NAME = ADM1_NAME.x,
#   #        ADM0_CODE = ADM0_CODE.x,
#   #        ADM0_NAME = ADM0_NAME.x,
#          name_adm1 = name_adm1.x, 
#          iso3 =iso3.x) %>%
#   write.csv(here("Input_data", "prod_tnuts_spam_gaul1.csv"))

treenut_pd = as_tibble(join_ha_pd_gaul) %>% 
  # rename(G2008_1_ID = G2008_1) %>%
  left_join(.,as_tibble(SPAM_GAUL_JOIN), by="G2008_1_ID") %>% 
  right_join(., prd_dat, by="alloc_key") %>% 
  dplyr::select(alloc_key, G2008_1_ID, ADM1_CODE, ADM1_NAME.x, ADM0_CODE.x, ADM0_NAME.x,
                name_cntr, name_adm1.x, iso3.x, rec_type, tech_type, unit, whea:rest, tnuts_ratio_pd) %>%
  rename(name_adm1 = name_adm1.x,
         ADM1_NAME = ADM1_NAME.x,
         ADM0_CODE =ADM0_CODE.x,
         ADM0_NAME =ADM0_NAME.x,
         iso3 =iso3.x) %>%
  write_csv(here("Input_data", "prod_tnuts_spam_gaul1.csv"))
treenut_pd = read.csv(here("Input_data","prod_tnuts_spam_gaul1.csv"))


# Harvested area 
treenut_ha = as_tibble(join_ha_pd_gaul) %>% 
  # rename(G2008_1_ID = G2008_1) %>%
  left_join(.,as_tibble(SPAM_GAUL_JOIN), by="G2008_1_ID") %>% 
  right_join(.,har_dat , by="alloc_key") %>% 
  dplyr::select(alloc_key, G2008_1_ID, ADM1_CODE, ADM1_NAME.x, ADM0_CODE.x, ADM0_NAME.x,
                name_cntr, name_adm1.x, iso3.x, rec_type, tech_type, unit, whea:rest, tnuts_ratio_ha) %>%
  rename(name_adm1 = name_adm1.x,
         ADM1_NAME = ADM1_NAME.x,
         ADM0_CODE =ADM0_CODE.x,
         ADM0_NAME =ADM0_NAME.x,
         iso3 =iso3.x) %>%
  write.csv(here("Input_data", "ha_tnuts_spam_gaul1.csv"))
treenut_ha = read_csv(here("Input_data","ha_tnuts_spam_gaul1.csv"))

# physical area 
treenut_phys = as_tibble(join_ha_pd_gaul) %>% 
  # rename(G2008_1_ID=G2008_1) %>%
  left_join(.,as_tibble(SPAM_GAUL_JOIN), by="G2008_1_ID") %>% 
  right_join(.,phy_dat, by="alloc_key") %>% 
  dplyr::select(alloc_key, G2008_1_ID, ADM1_CODE, ADM1_NAME.x, ADM0_CODE.x, ADM0_NAME.x,
                name_cntr, name_adm1.x, iso3.x, rec_type, tech_type, unit, whea:rest, tnuts_ratio_ha) %>%
  rename(name_adm1 = name_adm1.x,
         ADM0_CODE =ADM0_CODE.x,
         ADM0_NAME =ADM0_NAME.x,
         ADM1_NAME = ADM1_NAME.x,
         iso3 =iso3.x) %>%
  write.csv(here("Input_data", "phys_tnuts_spam_gaul1.csv"))
treenut_phys = read.csv(here("Input_data","phys_tnuts_spam_gaul1.csv"))



# Approach: Aim is to get dinal datasets on pixel level > Adm1 level
# 1_Cbind the three datasets 
# 2_Gather crops 
# 3_Spread levels rec type
# 4_Calculate yields after unit transformation  


# # GThis data contains all crops spread > Values correspond to the unaggregated SPAM dataset 
dat.phys = read_csv(here("Input_data", "phys_tnuts_spam_gaul1.csv"))  # this is pixel level spam
dat.prod = read_csv(here("Input_data", "prod_tnuts_spam_gaul1.csv"))  # this is pixel level spam
dat.harv = read_csv(here("Input_data", "ha_tnuts_spam_gaul1.csv"))    # this is pixel level spam

# calulating treenuts and rest from share ratio
dat_prod = treenut_pd %>%  mutate(tnuts = rest*tnuts_ratio_pd,
                                  rest = rest*(1-tnuts_ratio_pd)) %>%
  dplyr::select(-c(tnuts_ratio_pd)) %>% 
  write.csv(here("Input_data", "prod_tnuts_rest_spam_gaul_FINAL1.csv"))

dat_harv = dat.harv %>%  mutate(tnuts = rest*tnuts_ratio_ha,
                                rest = rest*(1-tnuts_ratio_ha)) %>%
  dplyr::select(-c(tnuts_ratio_ha))%>% 
  write.csv(here("Input_data", "harv_tnuts_rest_spam_gaul_FINAL.csv"))

dat_phys = dat.phys %>%  mutate(tnuts = rest*tnuts_ratio_ha,
                                rest = rest*(1-tnuts_ratio_ha)) %>%
  dplyr::select(-c(tnuts_ratio_ha)) %>%    
  write.csv(here("Input_data", "phys_tnuts_rest_spam_gaul_FINAL.csv"))

# This data contains  the final treenuts isolated from the initial rest. Rest here means now the herbs, etc
dat_phys = read_csv(here("Input_data", "phys_tnuts_rest_spam_gaul_FINAL.csv")) #tnutsratios good here -checked
dat_prod = read_csv(here("Input_data", "prod_tnuts_rest_spam_gaul_FINAL1.csv"))
dat_harv = read_csv(here("Input_data", "harv_tnuts_rest_spam_gaul_FINAL.csv"))
# head(dat.phys)
# head(dat.prod)
# head(dat.harv)

# lst.tnuts = list(dat.harv, dat.phys, dat.prod)
dat_nutsall <- do.call("rbind", list(dat_harv, dat_phys, dat_prod))

# Calculating the yield for nuts 
# yield_nut_dat = 
do.call("rbind", list(dat_harv, dat_phys, dat_prod)) %>% 
  dplyr::select(-c(X1)) %>%
  pivot_longer(names_to = "crops", values_to = "value", cols = whea:tnuts) %>% 
  pivot_wider(-unit, names_from = "rec_type", 
              values_from = "value") %>% 
  mutate(Y = (P*1000/H))%>% #checked for result. We are transforming mt to kg  when multiplying Production by 1000 to get unit kg/ha for yields
  mutate_at(vars(Y), ~replace(., is.nan(.), 0)) %>% 
  # rename(c("GID_0" ="GID_0.x", "GID_1"="GID_1.x")) %>% 
  write_csv(here("Input_data", "pxl_rec_spreadtec_gaul_spam_tnuts.csv"))
dat.all=read_csv(here("Input_data", "pxl_rec_spread_tec_gaul_spam_tnuts.csv"))













# 
# 
# 
# # OLD ---------------------------------------------------------------------
# # Loading the files and calculate final ratio -----------------------------
# wd2=setwd(here("Input_data"))
# 
# sph.prod1 = read_sf(dsn = wd2, layer = "GADM_treenut_rest_pd")
# sph.harv1 = read_sf(dsn = wd2, layer = "GADM_treenut_rest_ha")
# sph.all = st_join(sph.prod, sph.harv, join = st_within)
# write_sf(sph.all, dsn = here("Input_data"), driver = "ESRI Shapefile") #shapefile is called 'Input_data'
# 
# join_harv = st_join(SPAM_GADM_JOIN_GIS_left, sph.harv, join = st_intersects)
# join_harv_prod_SPAM_GADM = st_join(join_harv, sph.prod, join = st_intersects)
# 
# # Joining GADM with SPAM -------------------------------------------------------
# wd=setwd(here("Input_data"))
# 
# # Load and check shapefile 
# shape=read_sf(dsn = wd, layer = "gadm36") # multipolygons containing all admin levels globally
# shape=dplyr::select(shape, 'UID', 'geometry', 'GID_0', 'GID_1')
# # shape_fil=filter(shape, GID_0 == 'FIN')
# 
# # Making SPAM spatial explicit 
# dat_spam=read_csv(here("Input_data", "spam2010V2r0_global_Y_TA.csv"))
# dat_spam=dplyr::select(dat_spam, 'x','y', 'alloc_key')
# 
# # Make SPAM spatial 
# projcrs <- "+proj=longlat +datum=WGS84 +no_defs +ellps=WGS84 +towgs84=0,0,0"
# dat_cent <- st_as_sf(x = dat_spam,                         
#                      coords = c("x", "y"),
#                      crs = projcrs)
# 
# class(dat_cent)
# # dat_cent = filter(df, iso3=="FIN")
# 
# 
# SPAM_GADM_JOIN_GIS_left = st_join(dat_cent, shape, join = st_intersects, left = T) #https://postgis.net/docs/ST_Within.html 
# # head(SPAM_GADM_JOIN_GIS)
# # class(SPAM_GADM_Join)
# 
# st_write(obj = SPAM_GADM_JOIN_GIS, dsn = here("Input_data"), driver = "ESRI Shapefile")
# st_write(obj = SPAM_GADM_JOIN_GIS_left, dsn = here("Input_data"), driver = "ESRI Shapefile")
# 
# # Joining SPAM and GAUL 
# 
# 

