easypackages::packages(c("tidyverse", 'sf', 'raster','sp','dplyr','spatialEco',
                         'exactextractr','tibble', 'here', "readr"))

# Joining GADM with SPAM -------------------------------------------------------
wd=setwd(here("Input_data"))
# Load and check shapefile 
shape=read_sf(dsn = wd, layer = "gadm36") # multipolygons containing all admin levels globally
shape=dplyr::select(shape, 'UID', 'geometry', 'GID_0', 'GID_1')
# shape_fil=filter(shape, GID_0 == 'FIN')

# wd <- "D:/Raw_dat/Raw_dat/Phosphorus/nitrogen-fertilizer-global-geotif/NFertilizer_global_geotif"
# setwd(wd)

# Making SPAM spatial explicit 
dat_spam=read_csv(here("Input_data", "spam2010V2r0_global_Y_TA.csv"))
dat_spam=dplyr::select(dat_spam, 'x','y', 'alloc_key')

# Make SPAM spatial 
projcrs <- "+proj=longlat +datum=WGS84 +no_defs +ellps=WGS84 +towgs84=0,0,0"
dat_cent <- st_as_sf(x = dat_spam,                         
                     coords = c("x", "y"),
                     crs = projcrs)
class(dat_cent)
# dat_cent = filter(df, iso3=="FIN")

SPAM_GADM_JOIN_GIS = st_join(dat_cent, shape, join = st_within) #https://postgis.net/docs/ST_Within.html 
head(SPAM_GADM_JOIN_GIS)
class(SPAM_GADM_Join)

# Importing Zones with GAEZ from Spam -------------------------------------

zones=read_sf(here("Input_data","ARC_Pro_Input", "Zones_gaul2008_SpamID_AEZcode.shp"))
projcrs <- "+proj=longlat +datum=WGS84 +no_defs +ellps=WGS84 +towgs84=0,0,0"
zone1 <- st_as_sf(x = zones,                         
                     coords = c("x", "y"),
                     crs = projcrs)

zone2=zone1 %>% dplyr::select(AREA, G2008_1_ID, ADM1_CODE, ADM0_NAME, 
                              ADM1_NAME, CONTINENT, REGION, AEZ, iso3, cell5m, 
                              alloc_key, name_cntr, name_adm1, name_adm1, 
                              name_adm2, Shape_Area, geometry) %>%
  group_by(ADM0_NAME, AEZ) %>% 
  summarize()

plot(zone2)


